<?php
    $AjaxFunctions['showDropBehaviorGW'] = 'showDropBehaviorGW';
    $AjaxFunctions['formDropBehaviorGW'] = 'formDropBehaviorGW';
    $AjaxFunctions['saveDropBehaviorGW'] = 'saveDropBehaviorGW';
    $AjaxFunctions['deleteDropBehaviorGW'] = 'deleteDropBehaviorGW';
    $AjaxFunctions['showNotifyBehaviorGW'] = 'showNotifyBehaviorGW';
    $AjaxFunctions['formNotifyBehaviorGW'] = 'formNotifyBehaviorGW';
    $AjaxFunctions['saveNotifyBehaviorGW'] = 'saveNotifyBehaviorGW';
    $AjaxFunctions['deleteNotifyBehaviorGW'] = 'deleteNotifyBehaviorGW';
    $AjaxFunctions['showProfilesGW'] = 'showProfilesGW';
    $AjaxFunctions['formProfileGW'] = 'formProfileGW';
    $AjaxFunctions['saveProfileGW'] = 'saveProfileGW';
    $AjaxFunctions['deleteProfileGW'] = 'deleteProfileGW';
    $AjaxFunctions['setDefaultProfileGW'] = 'setDefaultProfileGW';

    ///////////////////////////////////////////////////////////////////////////
    // Behaviors
    ///////////////////////////////////////////////////////////////////////////

    function showDropBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );

        //TODO: implement SIPHeader
        $dropcomponents = array( 'SIPCode', /* 'SIPHeader', */
        'ISDNCause' );

        $yaml = new KGatewayProfileYaml( );

        $r = "<fieldset id='gateway-profile-drop-behavior'><legend>{$app->translate( 'gateway-profile-drop-behavior' )}</legend><div class='gateway-profile-drop-behavior'>";
        $r .= "<input type='button' value='{$app->translate( 'add' )}' class='gateway-profile-add-drop-behavior' /><br /><br />";

        if( $yaml->countDropBehaviors( ) === 0 )
        {
            $r .= "<p>{$app->translate( 'gateway-profile-error-no-behavior-found' )}</p>";
        }
        else
        {
            $r .= '<table class=\'gateway-table gateway-profile-drop-behaviors\'><thead>';
            $r .= "<tr><th>{$app->translate( 'Name' )}</th><th>{$app->translate( 'description' )}</th><th class='gateway-table-options'>{$app->translate( 'Options' )}</th></tr></thead><tbody>";
            foreach( $yaml->getAllDropBehaviors() as $behavior )
            {
                $components = array( );
                foreach( $dropcomponents as $c )
                {
                    $k = $app->translate( "gateway-profile-behavior-{$c}" );
                    if( isset( $behavior[$c] ) && $behavior[$c] )
                    {
                        $components[] = "{$k}: {$behavior[$c]}";
                    }
                }
                $components = implode( ', ', $components );
                $r .= "<tr><td>{$behavior['Name']}</td><td>{$components}</td><td class='gateway-table-options'><img class='gateway-profile-edit-drop-behavior' src='/imagens/editark.gif' title='{$app->translate( 'edit' )}' border='0' /><img class='gateway-profile-delete-drop-behavior' src='/imagens/lixeira.gif' title='{$app->translate( 'delete' )}' border='0' /></td></tr>";
            }
            $r .= '</tbody></table>';
        }

        $r .= "</div></fieldset>";

        return $r;
    }

    function formDropBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $_name = isset( $_POST['name'] ) ? $_POST['name'] : null;
        // new/blank form
        if( is_null( $_name ) )
        {
            $behavior = array( 'Name' => '', 'SIPCode' => '', 'SIPHeader' => '', 'ISDNCause' => '' );
        }
        else
        {
            $behavior = $yaml->getDropBehavior( $_name );
            if( is_null( $behavior ) )
            {
                return $app->translate( 'gateway-profile-error-behavior-not-found' );
            }
        }

        $r = '<table class=\'gateway-table-form\'>';
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-name'>{$app->translate( 'Name' )}</label></td><td><input type='text' id='gateway-profile-behavior-name' name='Name' value='{$behavior['Name']}' /><input type='hidden' name='__oldname__' value='{$behavior['Name']}' /></td></tr>";
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-SIPCode'>{$app->translate( 'gateway-profile-behavior-SIPCode' )}</label></td><td><input type='text' id='gateway-profile-behavior-SIPCode' name='SIPCode' value='{$behavior['SIPCode']}' /></td></tr>";
        //@formatter:off
        //TODO: activate when SIP HEADER gets implemented
        /*$r .= "<tr><td class='label'><label for='gateway-profile-behavior-SIPHeader'>{$app->translate( 'gateway-profile-behavior-SIPHeader' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-behavior-help-SIPHeader' class='gateway-tooltip' /></td><td><input type='text' id='gateway-profile-behavior-SIPHeader' name='SIPHeader' value='{$behavior['SIPHeader']}' /></td></tr>";*/
        //@formatter:on
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-ISDNCause'>{$app->translate( 'gateway-profile-behavior-ISDNCause' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-behavior-help-ISDNCause' class='gateway-tooltip' /></td><td><input type='text' id='gateway-profile-behavior-ISDNCause' name='ISDNCause' value='{$behavior['ISDNCause']}' maxlength='3' /></td></tr>";
        $r .= '</table><br />';
        $r .= "<input type='button' value='{$app->translate( 'save' )}' id='gateway-profile-behavior-save' />";
        $r .= "<input type='button' value='{$app->translate( 'back' )}' id='gateway-profile-behavior-back' />";
        return $r;
    }

    function saveDropBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-save' ) );

        try
        {
            $behavior = $_POST;
            if( isset( $behavior['__oldname__'] ) )
            {
                unset( $behavior['__oldname__'] );
            }
            $oldName = isset( $_POST['__oldname__'] ) && $_POST['__oldname__'] ? $_POST['__oldname__'] : '';
            $yaml->setDropBehavior( $behavior, $oldName );
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function deleteDropBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-delete' ) );

        try
        {
            $name = isset( $_POST['name'] ) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->deleteDropBehavior( $name ) )
            {
                throw new Exception( 'gateway-profile-behavior-error-not-found' );
            }
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-deleted' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function showNotifyBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );

        $yaml = new KGatewayProfileYaml( );

        $r = "<fieldset id='gateway-profile-notify-behavior'><legend>{$app->translate( 'gateway-profile-notify-behavior' )}</legend><div class='gateway-profile-notify-behavior'>";
        $r .= "<input type='button' value='{$app->translate( 'add' )}' class='gateway-profile-add-notify-behavior' /><br /><br />";

        if( $yaml->countNotifyBehaviors( ) === 0 )
        {
            $r .= "<p>{$app->translate( 'gateway-profile-error-no-behavior-found' )}</p>";
        }
        else
        {
            $r .= '<table class=\'gateway-table gateway-profile-notify-behaviors\'><thead>';
            $r .= "<tr><th>{$app->translate( 'Name' )}</th><th>{$app->translate( 'description' )}</th><th class='gateway-table-options'>{$app->translate( 'Options' )}</th></tr></thead><tbody>";
            foreach( $yaml->getAllNotifyBehaviors() as $behavior )
            {
                $r .= "<tr><td>{$behavior['Name']}</td><td>{$app->translate( 'gateway-profile-behavior-SIPHeader' )}: {$behavior['SIPHeader']}</td><td class='gateway-table-options'><img class='gateway-profile-edit-notify-behavior' src='/imagens/editark.gif' title='{$app->translate( 'edit' )}' border='0' /><img class='gateway-profile-delete-notify-behavior' src='/imagens/lixeira.gif' title='{$app->translate( 'delete' )}' border='0' /></td></tr>";
            }
            $r .= '</tbody></table>';
        }

        $r .= '</div></fieldset>';

        return $r;
    }

    function formNotifyBehaviorGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );

        $_name = isset( $_POST['name'] ) ? $_POST['name'] : null;
        // new/blank form
        if( is_null( $_name ) )
        {
            $behavior = array( 'Name' => '', 'SIPHeader' => '' );
        }
        else
        {
            $behavior = $yaml->getNotifyBehavior( $_name );
            if( is_null( $behavior ) )
            {
                return $app->translate( 'gateway-profile-error-behavior-not-found' );
            }
        }

        $r = '<table class=\'gateway-table-form\'>';
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-name'>{$app->translate( 'Name' )}</label></td><td><input type='text' id='gateway-profile-behavior-name' name='Name' value='{$behavior['Name']}' /><input type='hidden' name='__oldname__' value='{$behavior['Name']}' /></td></tr>";
        $r .= "<tr><td class='label'><label for='gateway-profile-behavior-SIPHeader'>{$app->translate( 'gateway-profile-behavior-SIPHeader' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-behavior-help-SIPHeader' class='gateway-tooltip' /></td><td><input type='text' id='gateway-profile-behavior-SIPHeader' name='SIPHeader' value='{$behavior['SIPHeader']}' /></td></tr>";
        $r .= '</table><br />';
        $r .= "<input type='button' value='{$app->translate( 'save' )}' id='gateway-profile-behavior-save' />";
        $r .= "<input type='button' value='{$app->translate( 'back' )}' id='gateway-profile-behavior-back' />";
        return $r;
    }

    function saveNotifyBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-save' ) );

        try
        {
            $behavior = $_POST;
            if( isset( $behavior['__oldname__'] ) )
            {
                unset( $behavior['__oldname__'] );
            }
            $oldName = isset( $_POST['__oldname__'] ) && $_POST['__oldname__'] ? $_POST['__oldname__'] : '';
            $yaml->setNotifyBehavior( $behavior, $oldName );
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function deleteNotifyBehaviorGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-behavior-delete' ) );

        try
        {
            $name = isset( $_POST['name'] ) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->deleteNotifyBehavior( $name ) )
            {
                throw new Exception( 'gateway-profile-behavior-error-not-found' );
            }
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-behavior-deleted' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    ///////////////////////////////////////////////////////////////////////////
    // Profiles
    ///////////////////////////////////////////////////////////////////////////

    function showProfilesGW( )
    {
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );

        $yaml = new KGatewayProfileYaml( );

        $r = "<fieldset id='gateway-profile-fs'><legend>{$app->translate( 'gateway-profiles' )}</legend><div class='gateway-profile'>";
        $r .= "<input type='button' value='{$app->translate( 'add' )}' class='gateway-profile-add' /><br /><br />";

        if( $yaml->countProfiles( ) === 0 )
        {
            $r .= "<p>{$app->translate( 'gateway-profile-error-no-profile-found' )}</p>";
        }
        else
        {
            $r .= '<table class=\'gateway-table gateway-profiles\'><thead>';
            $r .= "<tr><th>{$app->translate( 'Name' )}</th><th>{$app->translate( 'description' )}</th><th class='gateway-table-options'>{$app->translate( 'Options' )}</th></tr></thead><tbody>";
            foreach( $yaml->getAllProfiles() as $profile )
            {
                if( $yaml->isDefaultProfile( $profile['Name'] ) )
                {
                    $name = "<span style='font-weight: bold'>{$profile['Name']}</span>";
                    $optDefault = '';
                }
                else
                {
                    $name = $profile['Name'];
                    $optDefault = "<img class='gateway-profile-set-as-default' src='/imagens/refresh.png' border='0' title='{$app->translate( 'gateway-profile-set-as-default' )}' width='16' height='16' />'";
                }

                if( $profile['ReadOnly'] )
                {
                    $optEdit = '';
                    $optDelete = '';
                }
                else
                {
                    $optEdit = "<img class='gateway-profile-edit' src='/imagens/editark.gif' title='{$app->translate( 'edit' )}' border='0' />";
                    $optDelete = "<img class='gateway-profile-delete' src='/imagens/lixeira.gif' title='{$app->translate( 'delete' )}' border='0' />";
                }

                $description = _getProfileDescription( $profile );
                $r .= "<tr><td>{$name}</td><td>{$description}</td><td class='gateway-table-options'>{$optDefault}{$optEdit}<img class='gateway-profile-copy' src='/imagens/copy.gif' title='{$app->translate( 'copy' )}' border='0' />{$optDelete}</td></tr>";
            }
            $r .= '</tbody></table>';
        }

        $r .= '</div></fieldset>';
        return $r;
    }

    function _profileCauseMapInput( &$cause, $type )
    {
        return "<input type='text' id='gateway-profile-cause-map-{$cause['Id']}-{$type}' value='{$cause[$type]}' maxlength='3' class='gateway-profile-cause-map-input' />";
    }

    function formProfileGW( )
    {
        require_once KCONFIG . '/classes/KGatewayYaml.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        require_once KCONFIG . '/classes/KGatewayProfileAudioFileManager.php';
        require_once KROOT . '/classes/KLicense.php';

        $app = KSystem::getInstance( );

        $yaml = new KGatewayProfileYaml( );
        $gatewayyaml = new KGatewayYaml( );
        $manager = new KGatewayProfileAudioFileManager( );
        $lm = new KLicenseManager( );

        $_name = isset( $_POST['name'] ) ? $_POST['name'] : null;

        if( is_null( $_name ) )
        {
            //@formatter:off
            $profile = array(
                'Name' => '',
                'EnableFeatures' => array( 'EchoCanceller' ),
                'DisableFeatures' => array(),
                'FAX' => array(
                    'Mode' => 'T38'
                ),
                'R2' => array(
                    'DoubleAnswer' => array(
                        'Enabled' => false,
                        'Timeout' => 1000
                    )
                ),
                'SIP' => array(
                    'RelayExtensionHeaders' => false
                ),
                'Cadences' => array(
                    'Enabled' => true,
                    'Trying' => '25,500,25,2000',
                    'Ringback' => '1000,4000'
                ),
                'CallAnalyzer' => array(
                    'Enabled' => false,
                    'OnHumanAnswer' => array(
                        'Action' => 'Connect'
                    ),
                    'OnAnsweringMachine' => array(
                        'Action' => 'Connect'
                    ),
                    'OnCellPhoneMessageBox' => array(
                        'Action' => 'Connect'
                    ),
                    'OnCarrierMessage' => array(
                        'Action' => 'Connect'
                    ),
                    'OnUnknown' => array(
                        'Action' => 'Connect'
                    )
                )
            );
            //@formatter:on
            $defaultProfile = $yaml->getDefaultProfile( );
            $profile['CauseMap'] = $defaultProfile['CauseMap'];
            unset( $defaultProfile );
        }
        else
        {
            $profile = $yaml->getProfile( $_name );
            if( !$profile )
            {
                throw new Exception( 'gateway-profile-error-not-found' );
            }
        }

        if( isset( $_POST['copy'] ) && $_POST['copy'] )
        {
            $profile['Name'] = '';
        }

        $r = '<table class=\'gateway-table-form\'>';
        $r .= "<tr><td class='label'><label for='gateway-profile-name'>{$app->translate( 'Name' )}</label></td><td><input type='text' id='gateway-profile-name' name='Name' value='{$profile['Name']}' /><input type='hidden' id='gateway-profile-oldname' name='__oldname__' value='{$profile['Name']}' /></td></tr>";
        $r .= '</table><fieldset><legend>FAX</legend><table class=\'gateway-table-form\'>';
        $select = '<select id=\'gateway-profile-fax-mode\'>';
        foreach( KGatewayProfileYaml::$faxModes as $mode )
        {
            $selected = ($mode === $profile['FAX']['Mode']) ? ' selected' : '';
            $key = "gateway-profile-fax-mode-{$mode}";
            $select .= "<option value='{$mode}'{$selected}>{$app->translate( $key )}</option>";
        }
        $select .= '</select>';
        $r .= "<tr><td class='label'><label for='gateway-profile-fax-mode'>{$app->translate( 'gateway-profile-fax-mode' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-fax' class='gateway-tooltip' /></td><td>{$select}</td></tr>";
        unset( $select );
        $r .= '</table></fieldset>';
        $r .= '<fieldset><legend>R2</legend><table class=\'gateway-table-form\'><tbody>';
        $checked = $profile['R2']['DoubleAnswer']['Enabled'] ? ' checked=\'checked\'' : '';
        $r .= "<tr><td class='label'><label for='gateway-profile-r2-double-answer-enabled'>{$app->translate( 'gateway-profile-r2-double-answer' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-r2-double-answer' class='gateway-tooltip' /></td><td><input type='checkbox' id='gateway-profile-r2-double-answer-enabled'{$checked} /></td></tr>";
        $r .= "<tr><td class='label'><label for='gateway-profile-r2-double-answer-timeout'>{$app->translate( 'gateway-profile-r2-double-answer-timeout' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-r2-timeout' class='gateway-tooltip' /></td><td><input type='text' id='gateway-profile-r2-double-answer-timeout' value='{$profile['R2']['DoubleAnswer']['Timeout']}' maxlength='5' /></td></tr>";
        $r .= '</tbody></table></fieldset>';
        $r .= '<fieldset><legend>SIP</legend><table class=\'gateway-table-form\'><tbody>';
        $checked = $profile['SIP']['RelayExtensionHeaders'] ? ' checked=\'checked\'' : '';
        $r .= "<tr><td class='label'><label for='gateway-profile-sip-relay-extensions'></label>{$app->translate( 'gateway-profile-sip-relay-extensions' )}<img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-sip-relay-extensions' class='gateway-tooltip' /></td><td><input type='checkbox' id='gateway-profile-sip-relay-extensions'{$checked} /></td></tr>";
        $r .= '</tbody></table></fieldset>';
        $checked = $profile['Cadences']['Enabled'] ? ' checked=\'checked\'' : '';
        $r .= "<fieldset><legend><input type='checkbox' id='gateway-profile-cadences-enabled'{$checked} /> <label for='gateway-profile-cadences-enabled'>{$app->translate( 'gateway-profile-cadences' )}</label> <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-help-cadences' class='gateway-tooltip' /></legend><table class='gateway-table-form'>";
        unset( $checked );
        $input = _getCadenceInput( $profile, 'Trying' );
        $r .= "<tr><td class='label'><label for='gateway-profile-cadence-Trying-0'>{$app->translate( 'gateway-profile-cadence-trying' )}</label></td><td>{$input}</td></tr>";
        $input = _getCadenceInput( $profile, 'Ringback' );
        $r .= "<tr><td class='label'><label for='gateway-profile-cadence-Ringback-0'>{$app->translate( 'gateway-profile-cadence-ringback' )}</label></td><td>{$input}</td></tr>";
        unset( $input );
        $r .= '</table></fieldset>';
        $r .= "<fieldset><legend>{$app->translate( 'gateway-profile-features' )}</legend>";
        $r .= _getFeaturesConfig( $profile['DisableFeatures'], $profile['EnableFeatures'], 'gateway-profile-features' );
        $r .= '</fieldset>';
        // issue #5308, User defined Cause Map
        $r .= "<fieldset><legend><span id='gateway-profile-show-hide-cause-map'>+ {$app->translate( 'gateway-profile-cause-map' )}</span></legend>";
        $r .= "<table id='gateway-profile-cause-map-table' class='gateway-table-form hidden'><thead><tr><th>{$app->translate( 'gateway-profile-cause' )}</th><th>ISDN <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-cause-map-help-isdn' class='gateway-tooltip' /></th><th>R2 <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-cause-map-help-r2' class='gateway-tooltip' /></th><th>SIP <img src='/imagens/tooltip.png' border='0' khelp='gateway-profile-cause-map-help-sip' class='gateway-tooltip' /></th></tr></thead><tbody>";
        foreach( $profile['CauseMap'] as $cause )
        {
            $isdn = _profileCauseMapInput( $cause, 'ISDN' );
            $r2 = _profileCauseMapInput( $cause, 'R2' );
            $sip = _profileCauseMapInput( $cause, 'SIP' );
            $name = $app->translate( "gateway-profile-cause-map-name-{$cause['Id']}" );
            $r .= "<tr class='gateway-profile-cause-map'><td class='label'><input type='hidden' id='gateway-cause-map-{$cause['Id']}' value='${cause['Id']}' /><label for='gateway-profile-cause-map-{$cause['Id']}-ISDN'>{$cause['Id']}: {$name}</label></td><td>{$isdn}</td><td>{$r2}</td><td>{$sip}</td></tr>";
        }
        $r .= '</tbody></table></fieldset>';

        if( $gatewayyaml->isModel( KGatewayYaml::KMG3200 ) )
        {
            // AMG has support to call analyzer
            $checked = $profile['CallAnalyzer']['Enabled'] ? ' checked=\'checked\'' : '';
            $r .= "<fieldset id='gateway-profile-call-analyzer'><legend><input type='checkbox' id='gateway-profile-call-analyzer-enabled'{$checked} /> <label for='gateway-profile-call-analyzer-enabled'>{$app->translate( 'gateway-profile-call-analyzer' )}</label></legend>";
            unset( $checked );
            foreach( KGatewayProfileYaml::$callAnalyzerEvents as $event )
            {
                $r .= _getCallAnalyzerEventForm( $profile, $event, $yaml, $manager, $lm );
            }
            $r .= '</fieldset>';
        }

        $r .= "<br /><input type='button' value='{$app->translate( 'save' )}' id='gateway-profile-save' />";
        $r .= "<input type='button' value='{$app->translate( 'back' )}' id='gateway-profile-back' />";

        return $r;
    }

    function saveProfileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-save' ) );

        try
        {
            $profile = $_POST;
            if( isset( $profile['__oldname__'] ) )
            {
                unset( $profile['__oldname__'] );
            }
            $oldname = isset( $_POST['__oldname__'] ) && $_POST['__oldname__'] ? $_POST['__oldname__'] : null;

            $yaml->setProfile( $profile, $oldname );
            $yaml->save( );
            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-saved' ) );
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function deleteProfileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-delete' ) );

        try
        {
            $name = (isset( $_POST['name'] ) && $_POST['name']) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->deleteProfile( $name ) )
            {
                $reply['message'] = $app->translate( 'gateway-profile-error-not-found' );
            }
            else
            {
                $yaml->save( );
                $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-deleted' ) );
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }
        return JSONencode( $reply );
    }

    function setDefaultProfileGW( )
    {
        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
        $app = KSystem::getInstance( );
        $yaml = new KGatewayProfileYaml( );
        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-profile-error-set-default' ) );

        try
        {
            $name = (isset( $_POST['name'] ) && $_POST['name']) ? $_POST['name'] : null;
            if( is_null( $name ) || !$yaml->setDefaultProfile( $name ) )
            {
                $reply['message'] = $app->translate( 'gateway-profile-error-not-found' );
            }
            else
            {
                $yaml->save( );
                $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-profile-default-set' ) );
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ) );
        }

        return JSONencode( $reply );
    }

    function _getCadenceInput( $profile, $cadence )
    {
        $app = KSystem::getInstance( );
        $parts = explode( ',', $profile['Cadences'][$cadence] );
        $r = "<table><thead><tr><th>{$app->translate( 'gateway-profile-cadence-tone' )}</th><th>{$app->translate( 'gateway-profile-cadence-silence' )}</th><th>{$app->translate( 'gateway-profile-cadence-tone' )}</th><th>{$app->translate( 'gateway-profile-cadence-silence' )}</th></tr></thead><tbody><tr>";
        $extra = $profile['Cadences']['Enabled'] ? '' : ' disabled';
        for( $i = 0; $i < 4; $i++ )
        {
            $data = isset( $parts[$i] ) ? $parts[$i] : '';
            $r .= "<td><input type='text' id='gateway-profile-cadence-{$cadence}-{$i}' class='gateway-profile-cadence-input' value='{$data}' maxlength='4'{$extra} /></td>";
        }
        return "{$r}</tr></tbody></table>";
    }

    function _getCallAnalyzerEventForm( $profile, $event, KGatewayProfileYaml $yaml, KGatewayProfileAudioFileManager $manager, KLicenseManager $lm )
    {
        $app = KSystem::getInstance( );
        $key = "gateway-profile-call-analyzer-{$event}";
        $r = "<fieldset id='{$key}'><legend>{$app->translate( $key )}</legend>";
        $r .= '<table class=\'gateway-table-form\'><tbody>';
        $r .= "<tr><td class='label'><label for='{$key}-Action'>{$app->translate( 'gateway-profile-call-analyzer-action' )}</label></td><td><select id='{$key}-Action'>";
        foreach( KGatewayProfileYaml::$callAnalyzerActions as $action )
        {
            $s = ($profile['CallAnalyzer'][$event]['Action'] === $action) ? ' selected' : '';
            $k = "gateway-profile-call-analyzer-action-{$action}";
            $r .= "<option value='{$action}'{$s}>{$app->translate( $k )}</option>";
        }
        $r .= '</select></td></tr>';
        // PlayAndDrop action select file
        $needLicense = $lm->anyLicenseHasType( KLicense::TYPE_PLAYCHANNELS ) ? '' : '&nbsp;<img class=\'gateway-tooltip\' border=\'0\' src=\'/imagens/tooltip.png\' khelp=\'gateway-profile-help-audio-playback-may-need-license\' />';
        $r .= "<tr id='{$key}-PlayAndDrop'><td class='label'><label for='{$key}-AudioFile'>{$app->translate( 'gateway-profile-audio-file' )}</label>{$needLicense}</td><td><select id='{$key}-AudioFile'>";
        unset( $needLicense );
        foreach( $manager->getFiles() as $file => $data )
        {
            $s = (isset( $profile['CallAnalyzer'][$event]['AudioFile'] ) && $profile['CallAnalyzer'][$event]['AudioFile'] === $file) ? ' selected' : '';
            $d = $data[0] ? '' : ' disabled';
            $r .= "<option value='{$file}'{$s}{$d}>{$data[1]}</option>";
        }
        $r .= '</select></td></tr>';
        // Drop action select behavior
        $r .= "<tr id='{$key}-Drop'><td class='label'><label for='{$key}-DropBehavior'>{$app->translate( 'gateway-profile-drop-behavior' )}</label></td><td><select id='{$key}-DropBehavior'>";
        $_name = (isset( $profile['CallAnalyzer'][$event]['DropBehavior'] ) && $profile['CallAnalyzer'][$event]['DropBehavior']) ? $profile['CallAnalyzer'][$event]['DropBehavior'] : null;
        foreach( $yaml->getAllDropBehaviors() as $behavior )
        {
            $s = ($behavior['Name'] === $_name) ? ' selected' : '';
            $r .= "<option value='{$behavior['Name']}'{$s}>{$behavior['Name']}</option>";
        }
        $r .= '</select></td></tr>';
        // NotifyAndConnect action select behavior
        //@formatter:off
        /*
        $r .= "<tr id='{$key}-NotifyAndConnect'><td class='label'><label for='{$key}-NotifyBehavior'>{$app->translate( 'gateway-profile-notify-behavior' )}</label></td><td><select id='{$key}-NotifyBehavior'>";
        $_name = (isset( $profile['CallAnalyzer'][$event]['NotifyBehavior'] ) && $profile['CallAnalyzer'][$event]['NotifyBehavior']) ? $profile['CallAnalyzer'][$event]['NotifyBehavior'] : null;
        foreach( $yaml->getAllNotifyBehaviors() as $behavior )
        {
            $s = ($behavior['Name'] === $_name) ? ' selected' : '';
            $r .= "<option value='{$behavior['Name']}'{$s}>{$behavior['Name']}</option>";
        }
        $r .= '</select></td></tr>';
        */
        //@formatter:on
        $r .= '</tbody></table></fieldset>';
        return $r;
    }

    function _getProfileDescription( $profile )
    {
        $app = KSystem::getInstance( );

        $components = array( );
        if( isset( $profile['FAX']['Mode'] ) )
        {
            $faxmode = $app->translate( "gateway-profile-fax-mode-{$profile['FAX']['Mode']}" );
            $components[] = "FAX: {$faxmode}";
        }
        if( isset( $profile['R2']['DoubleAnswer']['Enabled'] ) && $profile['R2']['DoubleAnswer']['Enabled'] )
        {
            $components[] = "R2: {$app->translate( 'gateway-profile-r2-double-answer' )}";
        }
        if( isset( $profile['SIP']['RelayExtensionHeaders']) && $profile['SIP']['RelayExtensionHeaders'] )
        {
            $components[] = "SIP: {$app->translate( 'gateway-profile-sip-relay-extensions' )}";
        }

        if( isset( $profile['Cadences']['Enabled'] ) && $profile['Cadences']['Enabled'] )
        {
            $components[] = $app->translate( 'gateway-profile-cadences' );
        }

        if( isset( $profile['CallAnalyzer']['Enabled'] ) && $profile['CallAnalyzer']['Enabled'] )
        {
            $components[] = $app->translate( 'gateway-profile-call-analyzer' );
        }

        return implode( ', ', $components );
    }

    function _getFeaturesConfig( $disable, $enable, $class )
    {
        $app = KSystem::getInstance( );
        $r = "<table width='100%' class='{$class}-table gateway-table-form'><tbody>";
        foreach( KGatewayProfileYaml::$features as $feature )
        {
            $checked = in_array( $feature, $enable ) ? ' checked' : '';
            $key = "gateway-profile-feature-{$feature}";
            $r .= "<tr><td class='label'><label for='{$class}-{$feature}'>{$app->translate( $key )}</label></td><td><input type='checkbox' class='{$class}' id='{$class}-{$feature}' name='{$feature}' {$checked}/></td></tr>";
        }
        return $r . '</tbody></table>';
    }
