<?php
    @session_start( );

    $AjaxFunctions['showFax'] = 'showFax';
    $AjaxFunctions['saveFax'] = 'saveFax';
    $AjaxFunctions['showCallAnalyzer'] = 'showCallAnalyzer';
    $AjaxFunctions['saveCallAnalyzer'] = 'saveCallAnalyzer';
    $AjaxFunctions['showAutoCallAnalyzer'] = 'showAutoCallAnalyzer';
    $AjaxFunctions['showAutoEchoCanceller'] = 'showAutoEchoCanceller';
    $AjaxFunctions['showAutoDTMFSupression'] = 'showAutoDTMFSupression';
    $AjaxFunctions['showAutoAGC'] = 'showAutoAGC';
    $AjaxFunctions['showAutoDropCollectCall'] = 'showAutoDropCollectCall';

    $AjaxFunctions['getAssistant'] = 'getAssistant';

    function showFax( $_REQUEST )
    {
        Global $sistema;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= "<div id='Fax'>";
        $buff .= "<fieldset>";
        $buff .= "<legend>Fax</legend>";

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'NumeroPadraoFax' ) . "</td>";
        $buff .= "<td align='right'>";
        $ID = $sysYAML->getValue( 'ID' );
        $buff .= "<input id='ID' class='inputText' type='text' maxlength='20' value='{$ID}'  >";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'UseHeaderText' ) . "</td>";
        $buff .= "<td align='center' class='width110'>";
        $tmp = $sysYAML->getValue( 'UseHeader' );
        $UseHeader = $tmp == 'yamlError' ? 'false' : $tmp;
        $checked = getBooleanValue( $UseHeader )? 'checked' : '';
        $buff .= "<input name='UseHeader' id='UseHeader' value='' type='checkbox' $checked>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'HeaderText' ) . "</td>";
        $buff .= "<td align='right'>";
        $HeaderText = $sysYAML->getValue( 'HeaderText' );
        $buff .= "<input id='HeaderText' class='inputText' type='text' maxlength='20' value='{$HeaderText}' >";
        $buff .= "</td>";
        $buff .= "</tr>";
        $buff .= "</tbody></table>";
        $buff .= "</fieldset>";
        $buff .= '</br>';

        $buff .= "<div class='textAlignRight width99p'>";
        $buff .= "<input id='saveFaxB' type='button' onclick=\"saveFax();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "<br>";
        $buff .= "</div>";

        return $buff;
    }

    function saveFax( $_REQUEST )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $sysYAML = loadSystemYaml( );
            $data_arr = explode( ',', $data );

            foreach( $data_arr as $d )
            {
                $field = explode( '=', $d );
                $sysYAML->createVar($field[0], 'Fax', $field[1]);
            }
            $sysYAML->deleteVar('AddTimeout');

            $sysYAML->saveYaml( );
            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function make_select( $id, $options, $selected, $extra = array() )
    {
        $id = $extra['id'] ? $extra['id'] : $id;
        $name = $extra['name']? $extra['name'] : $id;
        unset($extra['id']);
        unset($extra['name']);
        $extra_attrib = http_build_query( $extra, '', ' ');
        $ret = "<select id='{$id}' name={$name} {$extra_attrib}>";
        foreach( $options as &$value )
        {
             $sel = $value == $selected? 'selected' : '';
             $ret .= "<option $sel>{$value}</option>";
        }
        $ret .= "</select>";
        return $ret;
    }

    function showCallAnalyzer( $_REQUEST )
    {
        Global $sistema;
        $sysYAML = loadSystemYaml( );

        $longRange = range(0, 60000, 100);
        $shortRange = range(0, 10000, 10);
        $analysisRange = range(2000, 60000, 100);

        $buff = '';
        $buff .= "<div id='CallAnalyser' >";
        $buff .= "<fieldset id='CallAnalyzerFields'>";
        $buff .= "<legend>Call analyzer</legend>";

        $buff .= "<table class='zebra'><tbody>";
        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'AnalysisTimeOutIncoming' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'AnalysisTimeOutIncoming', '', '15000' );
        $buff .= make_select('AnalysisTimeOutIncoming', $analysisRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'AnalysisTimeOutOutgoing' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'AnalysisTimeOutOutgoing', '', '3000' );
        $buff .= make_select( 'AnalysisTimeOutOutgoing', $analysisRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'Duration600Hz' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'Duration600Hz', '', '500' );
        $buff .= make_select( 'Duration600Hz', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'Tolerance600Hz' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'Tolerance600Hz', '', '150' );
        $buff .= make_select( 'Tolerance600Hz', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'FilterTolerance600Hz' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'FilterTolerance600Hz', '', '200' );
        $buff .= make_select( 'FilterTolerance600Hz', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'CellularBoxDuration' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'CellularBoxDuration', '', '450' );
        $buff .= make_select( 'CellularBoxDuration', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'CellularBoxTolerance' ) . "</td>";
        $buff .= "<td align='right'>";

        $current = $sysYAML->getValue( 'CellularBoxTolerance', '', '100' );
        $buff .= make_select( 'CellularBoxTolerance', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'CollectCallDuration' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'CollectCallDuration', '' , '450' );
        $buff .= make_select( 'CollectCallDuration', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'CollectCallTolerance' ) . "</td>";
        $buff .= "<td align='right'>";
        $current = $sysYAML->getValue( 'CollectCallTolerance', '', '100' );
        $buff .= make_select( 'CollectCallTolerance', $shortRange, $current);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'AnswerDuration' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'AnswerDuration', '', '150' );
        $buff .= make_select( 'AnswerDuration', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'AnswerSilenceDuration' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'AnswerSilenceDuration', '', '1000' );
        $buff .= make_select( 'AnswerSilenceDuration', $shortRange, $tmp );
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'AnswerFilterDuration' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'AnswerFilterDuration', '', '100' );
        $buff .= make_select( 'AnswerFilterDuration', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'PreVoiceDuration' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'PreVoiceDuration', '', '240' );
        $buff .= make_select( 'PreVoiceDuration', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        
        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'CustomCellBoxTimeout' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'CustomCellBoxTimeout', '', '1500' );
        $buff .= make_select( 'CustomCellBoxTimeout', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'MinRingbackTime' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'MinRingbackTime', '', '500' );
        $buff .= make_select('MinRingbackTime', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'MinVoiceTimeAsnweringMachine' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'MinVoiceTimeAsnweringMachine', '', '1400' );
        $buff .= make_select('MinVoiceTimeAsnweringMachine', $shortRange, $tmp);
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'ClassifyUnknownAnsweringMachine' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'ClassifyUnknownAnsweringMachine', '', 'false' );
        $checked = getBooleanValue( $tmp )? 'checked' : '';
        $buff .= "<input name='ClassifyUnknownAnsweringMachine' id='ClassifyUnknownAnsweringMachine' value='' type='checkbox' $checked>";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'WaitAnswerToComplete' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'WaitAnswerToComplete', '', 'true' );
        $checked = getBooleanValue( $tmp )? 'checked' : '';
        $buff .= "<input name='WaitAnswerToComplete' id='WaitAnswerToComplete' value='' type='checkbox' $checked>";
        $buff .= "$WaitAnswerToComplete";
        $buff .= "</td>";
        $buff .= "</tr>";

        $buff .= "<tr><td align='left'>" . $sistema->retTranslate( 'StartAtFirstTone' ) . "</td>";
        $buff .= "<td align='right'>";
        $tmp = $sysYAML->getValue( 'StartAtFirstTone', '', 'true' );
        $checked = getBooleanValue( $tmp )? 'checked' : '';
        $buff .= "<input name='StartAtFirstTone' id='StartAtFirstTone' value='' type='checkbox' $checked>";
        $buff .= "$StartAtFirstTone";
        $buff .= "</td>";
        $buff .= "</tr>";

        //inserir campos antes disto
        $buff .= "</table>";
        $buff .= "</fieldset>";

        //--------------------------------
        $buff .= "<tr><td align='left' colspan='2'>";
        $buff .= '<fieldset><legend>'. $sistema->retTranslate('CustomCellBoxFrequencies') . '</legend>';
        $buff .= "<table id='CustomCellBoxFrequencies'><thead>";
        $buff .= "<tr>";
        $buff .= "<th>" .$sistema->retTranslate( 'CustomCellBoxFrequency' ) ."</th>";
        $buff .= "<th>" .$sistema->retTranslate( 'CustomCellBoxDuration' ) ."</th>";
        $buff .= "<th>" .$sistema->retTranslate( 'CustomCellBoxTolerance' ) ."</th>";
        $buff .= "<th>" .$sistema->retTranslate( 'delete' )."</th>";
        $buff .= "<tr/></thead>";

        $buff .= "<tbody>";

        $defaultFreqs = array( 
            array( 'Frequency' => '720', 'Duration' => '300', 'Tolerance' => '100'),
            array( 'Frequency' => '300', 'Duration' => '210', 'Tolerance' => '60')
        );

        $tmp = $sysYAML->getValue("CustomCellBoxes", '', $defaultFreqs);
        foreach($tmp as $key => $value )
        {
            $buff .= createCustomCellBoxesRow( $value['Frequency'], $value['Duration'], $value['Tolerance'] );
        }
        
        $buff .= "</tbody></table>";
        $buff .= "<br />";
        $buff .= "<input id='addNewCustomCellBoxesRow' type='button' onclick='addNewCustomCellBoxFrequency();' value='". $sistema->retTranslate('CustomCellBoxNewFrequency'). "' />";
        $buff .= "</fieldset></td></tr>";
        //--------------

        $buff .= "</table>";
        $buff .= "</fieldset>";
        $buff .= '<br />';
        $buff .= "<div class='textAlignRight width99p'>";
        $buff .= "<input id='saveCallAnalyzerB' type='button' onclick=\"saveCallAnalyzer();\" value='" . $sistema->retTranslate( 'save' ) . "' />";
        $buff .= "</div>";
        $buff .= "<br />";
        $buff .= "</div>";

        //tabela somente com o valor padrao para ser inserido com JS ao clicar no botao.
        $buff .= "<table style='display:none;' id='CustomCellBoxesEmptyRow'>". createCustomCellBoxesRow( 300, 200, 100 ) . "</table>";

        return $buff;
    }

    function createCustomCellBoxesRow( $frequency, $duration, $tolerance )
    {
        global $sistema;
        $buff = "";

        $buff .= "<tr>";
        $buff .= "<td>";
        $buff .= make_select( 'Frequency', range(50,4000,5), $frequency );
        $buff .= "</td>";

        $buff .= "<td>";
        $buff .= make_select( 'Duration', range(10, 10000, 10), $duration );
        $buff .= "</td>";

        $buff .= "<td>";
        $buff .= make_select( 'Tolerance', range(10,200,10), $tolerance );
        $buff .= "</td>";

        $buff .= "<td><a href='#' onclick='removeCustomCellBoxFrequency(this);' >";
        $buff .= "<img src='/imagens/lixeira.gif' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "' />";
        $buff .= "</td></tr>";
        return $buff;
    }

    function createCadenceAssistant( $first = true )
    {
        Global $sistema;

        $buff = '';

        if( $first )
            $buff = "<div id='dialog-modal' title='" . $sistema->retTranslate( 'CadencesAssistant' ) . "'>";

        $buff .= "<p>Init Cadence Assistant</p>";
        $buff .= "<div id='looper'>";

        $FXOChannels = $sistema->getFXOChannels( );
        if( sizeof( $FXOChannels ) != 0 )
        {
            $buff .= "<form>";
            $buff .= "<table>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "Device" ) . "</td>";
            $buff .= "<td align='left'>" . getFXODevices( ) . "</td>";
            $buff .= "</tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "Channel" ) . "</td>";
            $buff .= "<td align='left' id='fxoDeviceChannelsList'>";
            $FXO = $sistema->getFirstFXODevice( );
            $buff .= getFXODeviceChannels( $FXO );
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "NumeroRamalLigacoes" ) . "</td>";
            $buff .= "<td align='left'>";
            $buff .= "<input id='busy' type='text' onkeyup='javascript: validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "NumeroRingBack" ) . "</td>";
            $buff .= "<td align='left'>";
            $buff .= "<input id='ringback' type='text' onkeyup='javascript: validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td align='left'>" . $sistema->retTranslate( "NumeroInvalido" ) . "</td>";
            $buff .= "<td align='left'>";
            $buff .= "<input id='invalid' type='text' onkeyup='javascript: validateNumber(this);' onmouseup='return numberMask(this, event);' onKeyPress='return numberMask(this, event);'>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "<tr>";
            $buff .= "<td colspan='2'>";
            $buff .= "<button type='button' onClick='initAssintant();'>" . $sistema->retTranslate( "gerarCadencias" ) . "</button>";
            $buff .= "</td>";
            $buff .= "</tr>";
            $buff .= "</table>";
            $buff .= "</form>";
        }
        // else
            // $buff .= $sistema->retTranslate( "NDevice4Assitance" );


        $buff .= "</div>";
        if( $first )
            // $buff .= "</div>";


        return $buff;
    }

    require_once KROOT . '/json_util.php';
    function saveCallAnalyzer( $_REQUEST )
    {
        Global $sistema;

        $data = isset( $_REQUEST['data'] ) ? $_REQUEST['data'] : NULL;

        if( isset( $data ) )
        {
            $ret = '';

            $syscfg = loadSystemYaml( );
            $data_arr = JSONdecode($data);
            $sysYaml = $syscfg->getYaml();
            $sysYaml['CallAnalyzer'] = $data_arr;
            $syscfg->setYaml($sysYaml);
            $syscfg->saveYaml();

            return $sistema->retTranslate( 'ConfiguracaoSalva' );
        }
    }

    function showAutoCallAnalyzer( $_REQUEST, $createCadenceAssistant = true )
    {
        Global $sistema;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="AutoCallAnalyser" >';
        $buff .= '<fieldset>';
        $buff .= '<legend>Call analyzer</legend>';

        $ACCs = $sysYAML->getValue( 'AutoCallAnalyzer' );
        $finalACCs = array( );
        if( $ACCs != '' )
            $finalACCs = explode( ", ", $ACCs );
        $AutoCallAnalyzer = $finalACCs;
        $AutoCallAnalyzerValue = $sysYAML->getValue( 'AutoCallAnalyzer' );

        $AutoCallAnalyzerSize = sizeof( $AutoCallAnalyzer );

        $buff .= "<div id='AutoCallAnalyserList'>";
        $buff .= "<input type='hidden' id='AutoCallAnalyserValue' name='AutoCallAnalyserValue' value='$AutoCallAnalyzerValue'/>";
        $buff .= "<table class='zebra'>";

        if( $AutoCallAnalyzerSize > 0 )
        {
            $buff .= "<thead><tr><td>" . $sistema->retTranslate( 'FaixaCA' ) ."</td>";
            $buff .= "<td></td></tr></thead><tbody>";

            for( $x = 0; $x < $AutoCallAnalyzerSize; $x++ )
            {
                $subAutoCallAnalyzer = explode( '.', $AutoCallAnalyzer[$x] );
                $buff .= '<tr><td>' . getSentence( $AutoCallAnalyzer[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"javascript: removeACAanalyzer('$AutoCallAnalyzer[$x]');\">";
                $buff .= "<img src='/imagens/lixeira.gif' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= "</td></tr>";
            }
        }
        else
            $buff .= "<tr><td>" . $sistema->retTranslate( 'NAutoCallAnalyzer' ) . "</td></tr>";

        $buff .= "</tbody></table>";
        $buff .= "</div>";
        $buff .= "</fieldset>";
        $buff .= '</br>';
        $buff .= "<input type='button' onclick=\"javascript: initAssistant('ACAnalyzer');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= "</div>";

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function showAutoEchoCanceller( $_REQUEST, $showAutoEchoCanceller = true )
    {
        Global $sistema;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="AutoEchoCanceller"><fieldset>';
        $buff .= '<legend>' . $sistema->retTranslate( 'AutoEchoCanceller' ) . '</legend>';

        $AECs = $sysYAML->getValue( 'AutoEchoCanceller' );
        $finalAECs = array( );
        if( $AECs != '' )
            $finalAECs = explode( ", ", $AECs );
        $AutoEchoCanceller = $finalAECs;

        $AutoEchoCancellerValue = $sysYAML->getValue( 'AutoEchoCanceller' );
        $AutoEchoCancellerSize = sizeof( $AutoEchoCanceller );

        $buff .= '<div id="AutoEchoCancellerList">';
        $buff .= "<input type='hidden' id='AutoEchoCancellerValue' name='AutoEchoCancellerValue' value='$AutoEchoCancellerValue'/>";
        $buff .= "<table class='zebra'>";

        if( $AutoEchoCancellerSize > 0 )
        {
            $buff .= '<thead><tr><td>' . $sistema->retTranslate( 'FaixaCE' ) . '</td><td></td></tr></thead><tbody>';
            for( $x = 0; $x < $AutoEchoCancellerSize; $x++ )
            {
                $buff .= '<tr><td>' . getSentence( $AutoEchoCanceller[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"javascript: removeAECancel('$AutoEchoCanceller[$x]')\">";
                $buff .= "<img src='/imagens/lixeira.gif' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
        }
        else
            $buff .= '<tr><td>' . $sistema->retTranslate( 'NAutoEchoCanceller' ) . '</td></tr>';

        $buff .= '</tbody></table>';
        $buff .= '</div>';

        $buff .= '</fieldset>';
        $buff .= '<br>';
        $buff .= "<input type='button' onclick=\"javascript: initAssistant('AECancel');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= '</div>';

        if( $showAutoEchoCanceller )
            $buff .= createCadenceAssistant( );

        return $buff;

    }

    function showAutoDTMFSupression( $_REQUEST, $createCadenceAssistant = true )
    {
        Global $sistema;

        $sysYAML = loadSystemYaml( );

        $buff = '';

        $buff .= '<div id="AutoDtmfSuppression" >';
        $buff .= '<fieldset>';
        $buff .= '<legend>' . $sistema->retTranslate( 'AutoDtmfSuppression' ) . '</legend>';

        $ADSs = $sysYAML->getValue( 'AutoDtmfSuppression' );
        $finalADSs = array( );
        if( $ADSs != '' )
            $finalADSs = explode( ", ", $ADSs );
        $AutoDtmfSuppression = $finalADSs;

        $AutoDtmfSuppressionValue = $sysYAML->getValue( 'AutoDtmfSuppression' );
        $AutoDtmfSuppressionSize = sizeof( $AutoDtmfSuppression );

        $buff .= '<div id="AutoDtmfSuppressionList">';
        $buff .= "<input type='hidden' id='AutoDtmfSuppressionValue' name='AutoDtmfSuppressionValue' value='$AutoDtmfSuppressionValue'/>";
        $buff .= "<table class='zebra'>";

        if( $AutoDtmfSuppressionSize > 0 )
        {
            $buff .= '<thead<tr><td>' . $sistema->retTranslate( 'FaixaADSup' ) . '</td><td></td></tr></thead><tbody>';

            for( $x = 0; $x < $AutoDtmfSuppressionSize; $x++ )
            {
                $buff .= '<tr><td>' . getSentence( $AutoDtmfSuppression[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"javascript: removeADSupression('$AutoDtmfSuppression[$x]')\">";
                $buff .= "<img src='/imagens/lixeira.gif' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
        }
        else
            $buff .= '<tr><td>' . $sistema->retTranslate( 'NAutoEchoCanceller' ) . '</td></tr>';

        $buff .= '</tbody></table>';
        $buff .= '</span>';

        $buff .= '</fieldset>';
        $buff .= '<br>';
        $buff .= "<input type='button' onclick=\"javascript: initAssistant('ADSup');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= '</div>';

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function showAutoAGC( $_REQUEST, $createCadenceAssistant = true )
    {
        Global $sistema;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="AutoAGC">';
        $buff .= '<fieldset>';
        $buff .= '<legend>AGC</legend>';

        $AAGCs = $sysYAML->getValue( 'AutoAGC' );
        $finalAAGCs = array( );

        if( $AAGCs != '' )
            $finalAAGCs = explode( ", ", $AAGCs );
        $AutoAGC = $finalAAGCs;
        $AutoAGCValue = $sysYAML->getValue( 'AutoAGC' );

        $AutoAGCSize = sizeof( $AutoAGC );
        $buff .= '<div id="AutoAGCList">';
        $buff .= "<input type='hidden' id='AutoAGCValue' name='AutoAGCValue' value='$AutoAGCValue'/>";
        $buff .= '<table class="zebra">';

        if( $AutoAGCSize > 0 )
        {
            $buff .= '<thead><tr><td>' . $sistema->retTranslate( 'FaixaAAGC' ) . '</td><td></td></tr></thead><tbody>';
            for( $x = 0; $x < $AutoAGCSize; $x++ )
            {
                $buff .= '<tr><td>' . getSentence( $AutoAGC[$x] ) . '</td><td>';
                $buff .= "<a href='#' onClick=\"javascript: removeAAGC('$AutoAGC[$x]');\">";
                $buff .= "<img src='/imagens/lixeira.gif' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
        }
        else
            $buff .= '<tr><td>' . $sistema->retTranslate( 'NAutoEchoCanceller' ) . '</td></tr>';
        $buff .= '</tbody></table>';
        $buff .= '</div>';

        $buff .= '</fieldset>';
        $buff .= '<br>';
        $buff .= "<input type='button' onclick=\"javascript: initAssistant('AAGC');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";
        $buff .= '</div>';

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function showAutoDropCollectCall( $_REQUEST, $createCadenceAssistant = true )
    {
        Global $sistema;

        $sysYAML = loadSystemYaml( );

        $buff = '';
        $buff .= '<div id="DropCollectCalls">';
        $buff .= '<fieldset>';
        $buff .= '<legend>' . $sistema->retTranslate( 'DropCollectCalls' ) . '</legend>';
        $DCCs = $sysYAML->getValue( 'DropCollectCalls' );

        $finalDCCs = array( );
        $keys = array_keys( $DCCs );
        for( $i = 0; $i < sizeof( $keys ); $i++ )
            $finalDCCs[] = $keys[$i];
        $DropCollectCalls = $finalDCCs;
        $DropCollectCallsSize = sizeof( $DropCollectCalls );

        $buff .= '<div id="DropCollectCallsList">';
        $buff .= "<input type='hidden' id='DropCollectCallsTotal' name='DropCollectCallsTotal' value='$DropCollectCallsSize'/>";
        $buff .= '<table class="zebra">';

        if( $DropCollectCallsSize > 0 )
        {
            $buff .= '<thead><tr><th>' . $sistema->retTranslate( 'Description' ) . '</th>';
            $buff .= '<th>' . $sistema->retTranslate( 'Configuration' ) . '</th>';
            $buff .= '<th>' . $sistema->retTranslate( 'options' ) . '</th></tr></thead><tbody>';
            for( $x = 0; $x < $DropCollectCallsSize; $x++ )
            {
                $buff .= "<tr>";
                $buff .= '<td width="30%">';
                $subDropCollectCalls = explode( '.', $DropCollectCalls[$x] );
                $buff .= getSentence( $DropCollectCalls[$x] );
                $buff .= '</td><td>';
                $value = $sysYAML->getValue( $DropCollectCalls[$x], 'Features|DropCollectCalls' );

                if( $value == 'yamlError' )
                    $value = "";

                $buff .= printDropCollectCall( $DropCollectCalls[$x], $x, $value );
                $buff .= '</td><td>';
                $buff .= "<a href='#' onClick=\"javascript: removeDCCall('$DropCollectCalls[$x]');\">";
                $buff .= "<img src='/imagens/lixeira.gif' alt='" . $sistema->retTranslate( "remove" ) . "' title='" . $sistema->retTranslate( "remove" ) . "'/></a>";
                $buff .= '</td></tr>';
            }
        }
        else
            $buff .= '<tr><td>' . $sistema->retTranslate( 'NDropCollectCalls' ) . '</td></tr>';

        $buff .= '</tbody></table>';
        $buff .= '</div>';
        $buff .= '</fieldset>';
        $buff .= '</br>';

        $buff .= "<input type='button' onclick=\"javascript: initAssistant('DCCall');\" value='" . $sistema->retTranslate( 'AddRule' ) . "'>";

        if( $DropCollectCallsSize > 0 )
            $buff .= "<input type='button' class='floatRight' onclick=\"saveDCCallConfigs('$DropCollectCallsSize');\" value='Salvar'>";

        $buff .= '</div>';

        if( $createCadenceAssistant )
            $buff .= createCadenceAssistant( );

        return $buff;
    }

    function getAssistant( $_REQUEST )
    {
        Global $sistema;

        $type = isset( $_REQUEST['type'] ) ? $_REQUEST['type'] : NULL;

        if( isset( $type ) )
        {
            $divName = '';

            switch($type)
            {
                case 'ACAnalyzer':
                    $divName = 'AutoCallAnalyser';
                    break;
                case 'AECancel':
                    $divName = 'AutoEchoCanceller';
                    break;
                case 'ADSup':
                    $divName = 'AutoDtmfSuppression';
                    break;
                case 'AAGC':
                    $divName = 'AutoAGC';
                    break;
                case 'DCCall':
                    $divName = 'DropCollectCalls';
                    break;
            }
            $return = '';
            $return .= "<div id='tabs'>";
            $return .= "<ul>";
            $return .= "<li><a href='#tabs-0' onClick=\"javascript: changeWCSubType('Device');\">" . $sistema->retTranslate( "Device" ) . "</a></li>";
            $return .= "<li><a href='#tabs-1' onClick=\"javascript: changeWCSubType('Links');\">" . $sistema->retTranslate( "Links" ) . "</a></li>";
            $return .= "<li><a href='#tabs-2' onClick=\"javascript: changeWCSubType('Channel');\">" . $sistema->retTranslate( "Channel" ) . "</a></li>";
            $return .= "<li><a href='#tabs-3' onClick=\"javascript: changeWCSubType('Tech');\">" . $sistema->retTranslate( "Technology" ) . "</a></li>";
            $return .= "<li><a href='#tabs-4' onClick=\"javascript: changeWCSubType('All');\">" . $sistema->retTranslate( "All" ) . "</a></li>";
            $return .= "</ul>";
            $return .= "<div id='tabs-0'>";
            $return .= "<p>" . getDeviceForm( ) . "</p>";
            $return .= "</div>";
            $return .= "<div id='tabs-1'>" . getLinksForm( ) . "</div>";
            $return .= "<div id='tabs-2'>" . getChannelForm( ) . "</div>";
            $return .= "<div id='tabs-3'>" . getTechForm( ) . "</div>";
            $return .= "<div id='tabs-4'>";
            $return .= "<p>" . $sistema->retTranslate( "TodasDevicesCanais" ) . "</p>";
            $return .= "</div>";
            $return .= "</div>";
            $return .= "<br>";
            $return .= "<input type='button' onClick=\"saveAssistant('$divName');\" value='" . $sistema->retTranslate( "add" ) . "' />";
            $return .= '<input type="hidden" value="' . $type . '" name="WCType" id="WCType" />';
            $return .= '<input type="hidden" value="Device" name="WCSubType" id="WCSubType" />';
            return $return;
        }
    }

    /********** aux functions ****************/

    function printDropCollectCall( $DeviceChannel, $number, $value = "" )
    {
        Global $sistema;

        $return = "<table border='0'>";
        $return .= "<tr>";
        $return .= "<td align='left'>";
        $return .= $sistema->retTranslate( "BlockResponse" );
        $return .= "</td>";
        $return .= "<td valign='top' align='right'>";
        $options = array( "Busy", "Invalid number", "Out of service" );
        $return .= "<select name='DropCollectCallsC$number' id='DropCollectCallsC$number' >";
        $valueBlockResponse = $value['BlockResponse'];

        if( $valueBlockResponse == "" )
            $optionValue = "Busy";
        else
            $optionValue = $valueBlockResponse;

        for( $st = 0; $st < sizeof( $options ); $st++ )
        {
            if( $options[$st] == $optionValue )
                $selected = "selected";
            else
                $selected = "";
            $return .= "<option value='$options[$st]' $selected>$options[$st]</option>";
        }

        $return .= "</select>";
        $return .= "</td>";
        $return .= "</tr>";

        $return .= "<tr>";
        $return .= "<td align='left'>" . $sistema->retTranslate( "DoubleAnswerDelay" ) . "</td>";
        $return .= "<td valign='top' align='right'>";
        $return .= "<select name='DropCollectCallsF$number' id='DropCollectCallsF$number' >";

        $valueDoubleAnswerDelay = isset( $value['DoubleAnswerDelay'] ) ? $value['DoubleAnswerDelay'] : NULL;
        if( !isset( $valueDoubleAnswerDelay ) )
            $intValue = 500;
        else
            $intValue = $valueDoubleAnswerDelay;

        for( $st = 0; $st < 2000; $st += 50 )
        {
            if( $st == $intValue )
                $selected = "selected";
            else
                $selected = "";
            $return .= "<option value='$st' $selected>$st</option>";
        }

        $return .= "</select>";
        $return .= "</td>";
        $return .= "</tr>";
        $return .= "<tr>";

        $valueAutoBlock = $value['AutoBlock'];
        if( getBooleanValue( $valueAutoBlock ) )
            $checked = "checked";
        else
            $checked = "";

        $return .= "<td align='left'>" . $sistema->retTranslate( "AutoBlock" ) . "</td>";
        $return .= "<td align='right'>";

        $tmp = explode( ".", $DeviceChannel );
        if( !isset( $tmp[1] ) )
            $tmp[1] = "*";

        $DeviceChannel = implode( ".", $tmp );
        $return .= "<input type='hidden' id='DropCollectCallsA$number' name='DropCollectCallsA$number' value='$DeviceChannel'/>";
        $return .= "<input class='checkbox' name='DropCollectCallsB$number' id='DropCollectCallsB$number' value='' type='checkbox' $checked>";
        $return .= "</td>";
        $return .= "</td>";
        $return .= "</tr>";

        if( !IS_GATEWAY )
        {
            $return .= "<tr>";
            $valueDropCallAnalyzer = $value['DropCallAnalyzer'];
            if( getBooleanValue( $valueDropCallAnalyzer ) )
                $checked = "checked";
            else
                $checked = "";
    
            $return .= "<td align='left'>" . $sistema->retTranslate( "DropCallAnalyzer" ) . "</td>";
            $return .= "<td align='right'>";
            $return .= "<input class='checkbox' name='DropCollectCallsD$number' id='DropCollectCallsD$number' value='' type='checkbox' $checked> ";
            $return .= "</td>";
            $return .= "</tr>";
        }

        $return .= "<tr>";
        $valueAutoDoubleAnswer = $value['AutoDoubleAnswer'];

        if( getBooleanValue( $valueAutoDoubleAnswer ) )
            $checked = "checked";
        else
            $checked = "";

        $return .= "<td align='left'>" . $sistema->retTranslate( "AutoDoubleAnswer" ) . "</td>";
        $return .= "<td align='right'>";
        $return .= "<input class='checkbox' name='DropCollectCallsE$number' id='DropCollectCallsE$number' value='' type='checkbox' $checked>";
        $return .= "</td>";
        $return .= "</td>";
        $return .= "</tr>";
        $return .= "</table>";

        return $return;
    }

    function getSentence( $DCC )
    {
        Global $sistema;
        $suDCC = explode( ".", $DCC );

        if( !isset( $suDCC[1] ) )
            $suDCC[1] = '*';

        $sentence = '';

        if( $suDCC[0] == "*" && $suDCC[1] == "*" )
        {
            $sentence = $sistema->retTranslate( "TDeviceCahnnels" );
        }
        elseif( @ereg( "\[", $suDCC[1] ) )
        {
            // extens�o do cannal tanto ao tanto no dipositivo x
            $tnpSC = explode( "-", $suDCC[1] );
            $SC = substr( $tnpSC[0], 1 );
            $EC = substr( $tnpSC[1], 0, (strlen( $tnpSC[1] ) - 1) );
            $sentence = $sistema->retTranslate( "extFrom" ) . " $SC " . $sistema->retTranslate( "to" ) . " $EC " . $sistema->retTranslate( "atDevice" ) . " " . $suDCC[0];
        }
        elseif( $suDCC[1] == "FXO" || $suDCC[1] == "FXS" || $suDCC[1] == "E1" || $suDCC[1] == "GSM" )
        {
            // todos os dispositivos que usam tecnologia x
            $sentence = $sistema->retTranslate( "TDevices" ) . " " . $suDCC[1];
        }
        elseif( $suDCC[0] != "*" && $suDCC[1] == "*" )
        {
            //dispositivo x
            $sentence = $sistema->retTranslate( "TChannelsFromdevice" ) . " " . $suDCC[0];
        }
        elseif( $suDCC[0] != "*" && $suDCC[1] != "*" )
        {
            // link x no dispositivo y
            $sentence = $sistema->retTranslate( "link" ) . " " . $suDCC[1] . " " . $sistema->retTranslate( "atDevice" ) . " " . $suDCC[0];
        }
        return $sentence;
    }
?>
