<?php
    require_once KCONFIG . '/classes/classKYaml.php';


    if( PHP_OS == 'WINNT' )
    {
        //  strptime is not implemented in Windows systems
        // implementation from: http://php.net/manual/en/function.strptime.php
        function strptime($date, $format) { 
            $masks = array( 
              '%d' => '(?P<d>[0-9]{2})', 
              '%m' => '(?P<m>[0-9]{2})', 
              '%Y' => '(?P<Y>[0-9]{4})', 
              '%H' => '(?P<H>[0-9]{2})', 
              '%M' => '(?P<M>[0-9]{2})', 
              '%S' => '(?P<S>[0-9]{2})', 
             // usw.. 
            ); 

            $rexep = "#".strtr(preg_quote($format), $masks)."#"; 
            if(!preg_match($rexep, $date, $out)) 
              return false; 

            $ret = array( 
              "tm_sec"  => (int) $out['S'], 
              "tm_min"  => (int) $out['M'], 
              "tm_hour" => (int) $out['H'], 
              "tm_mday" => (int) $out['d'], 
              "tm_mon"  => $out['m']?$out['m']-1:0, 
              "tm_year" => $out['Y'] > 1900 ? $out['Y'] - 1900 : 0, 
            ); 
            return $ret; 
        } 
    }


    class KGatewayYamlException extends KYamlException
    {
    }

    class KGatewayYaml extends KYaml
    {
        private static $kgatewayprofileyaml = null;
        private static $audittimefmt = '%Y-%m-%d %H:%M:%S';
        public static $cdrrotateoptions = array( 'every minute', 'hourly', 'daily' );
        public static $g729b = array( 'G729', 'G729B' );

        private $model = 0;
        private $maxebs = 0;

        const KMG100 = 100;
        const KMG200 = 200;
        const KMG400 = 400;
        const KMG3200 = 3200;

        public function __construct( )
        {
            // validation rules
            //@formatter:off
            $this->rules = array(
                'NAPs' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING,
                                ),
                                'Type' => array(
                                    'type' => KYaml::TYPE_STRING,
                                ),
                                'Profile' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                //SIP
                                'Register' => array(
                                    'type' => KYaml::TYPE_BOOLEAN,
                                    'flags' => KYaml::FLAG_NOTREQUIRED,
                                    'default' => 'false'
                                ),
                                'Proxy' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'ProxyPort' => array(
                                    'type' => KYaml::TYPE_INTEGER,
                                    'default' => 0,
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'Username' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                'Password' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'Domain' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                'DomainPort' => array(
                                    'type' => KYaml::TYPE_INTEGER,
                                    'default' => 0,
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                'DomainUseIpPacketAddress' => array(
                                    'type' => KYaml::TYPE_BOOLEAN,
                                    'default' => false,
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                'AuthorizationUser' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'Expires' => array(
                                    'type' => KYaml::TYPE_INTEGER,
                                    'default' => 0,
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'UseCalledFromRequestURI' => array(
                                    'type' => KYaml::TYPE_BOOLEAN,
                                    'default' => false,
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                ),
                                //TRUNK
                                'Links' => array(
                                    'type' => KYaml::TYPE_LIST,
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                                    'default' => array(),
                                    'children' => array(
                                        '?' => array(
                                            'type' => KYaml::TYPE_STRING
                                        )
                                    ) // NAPs.?.Links
                                )
                            ) // NAPs.?
                        )
                    ) // NAPs
                ),
                'CodecProfiles' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'CodecList' => array(
                                    'type' => KYaml::TYPE_LIST,
                                    'flags' => KYaml::FLAG_NORMALIZE,
                                    'children' => array(
                                        '?' => array(
                                            'type' => KYaml::TYPE_STRING
                                        )
                                    ) // CodecProfiles.?.CodecList
                                )
                            ) // CodecProfiles.?
                        )
                    ) // CodecProfiles
                ),
                'Routes' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'OriginNAP' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'Called' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'Caller' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'RemapCalled' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'RemapCaller' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'DestinationNAP' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'Time' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                //SIP
                                'CodecProfile' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_NOTREQUIRED | KYaml::FLAG_EMPTY
                                ),
                                'DestinationProfile' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'flags' => KYaml::FLAG_NOTREQUIRED
                                )
                            ) // Routes.?
                        )
                    ) // Routes
                ),
                'TimeRestraints' => array(
                    'type' => KYaml::TYPE_LIST,
                    'flags' => KYaml::FLAG_EMPTY | KYaml::FLAG_NORMALIZE,
                    'default' => array(),
                    'children' => array(
                        '?' => array(
                            'type' => KYaml::TYPE_LISTHASH,
                            'children' => array(
                                'Name' => array(
                                    'type' => KYaml::TYPE_STRING
                                ),
                                'Hour' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'WDay' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'Day' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                ),
                                'Month' => array(
                                    'type' => KYaml::TYPE_STRING,
                                    'default' => '',
                                    'flags' => KYaml::FLAG_EMPTY
                                )
                            ) // TimeRestraints.?
                        )
                    ) // TimeRestraints
                ),
                'CDR' => array(
                    'type' => KYaml::TYPE_LISTHASH,
                    'children' => array(
                        'Pattern' => array(
                            'type' => KYaml::TYPE_STRING
                        ),
                        'Rotate' => array(
                            'type' => KYaml::TYPE_STRING
                        ),
                        'BasePath' => array(
                            'type' => KYaml::TYPE_STRING
                        ),
                        'Enabled' => array(
                            'type' => KYaml::TYPE_BOOLEAN,
                            'default' => true,
                            'flags' => KYaml::FLAG_NOTREQUIRED
                        )
                    ) // CDR
                ),
                //TODO: mark as deprecated??
                'MaxEbs' => array(
                    'type' => KYaml::TYPE_INTEGER,
                    'default' => 1
                ), // MaxEbs
                'Audit' => array(
                    'type' => KYaml::TYPE_LISTHASH,
                    'flags' => KYaml::FLAG_NOTREQUIRED,
                    'children' => array(
                        'Start' => array(
                            'type' => KYaml::TYPE_STRING,
                            'flags' => KYaml::FLAG_EMPTY,
                            'default' => ''
                        ),
                        'End' => array(
                            'type' => KYaml::TYPE_INTEGER,
                            'default' => 5
                        ),
                        'WholeCall' => array(
                            'type' => KYaml::TYPE_BOOLEAN,
                            'default' => false
                        ),
                        'Routes' => array(
                            'type' => KYaml::TYPE_LIST,
                            'flags' => KYaml::FLAG_EMPTY,
                            'default' => array( ),
                            'children' => array(
                                '?' => array(
                                    'type' => KYaml::TYPE_STRING
                                )
                            ) // Audit.Routes.?
                        ) // Audit.Routes
                    )
                ) // Audit
            );
            //@formatter:on

            $app = KSystem::getInstance( );
            //TODO: windows support?
            $this->validationProgram = '/usr/sbin/khomp-sudo /etc/init.d/kgateway validate-config';
            parent::__construct( $app->getConfigDir( ) . DIRECTORY_SEPARATOR . 'gateway.yaml' );

            // the values from $this->model and $this->maxebs are cached in the
            // session to avoid fork n' exec each time this class is constructed
            if( !isset( $_SESSION['kgatewayyaml::model'] ) || !isset( $_SESSION['kgatewayyaml::maxebs'] ) )
            {
                $output = array( );
                $errcode = -1;
                //TODO: windows support?
                exec( "/usr/sbin/khomp-sudo /etc/init.d/kgateway model 2>&1", $output, $errcode );
                if( $errcode == 0 )
                {
                    // first output line should contains the gateway model
                    $this->model = intval( $output[0], 10 );
                    switch( $this->model )
                    {
                        case 100:
                        case 200:
                        case 400:
                            $this->maxebs = 1;
                            break;
                        case 3200:
                            $this->maxebs = 8;
                            break;
                        default:
                            // change to default values???
                            // issue warning???
                            $this->model = 0;
                            $this->maxebs = 0;
                            break;
                    }

                    if( $this->model > 0 && $this->maxebs > 0 )
                    {
                        $_SESSION['kgatewayyaml::model'] = $this->model;
                        $_SESSION['kgatewayyaml::maxebs'] = $this->maxebs;
                    }
                }
                // keep default values???
            }
            else
            {
                $this->model = $_SESSION['kgatewayyaml::model'];
                $this->maxebs = $_SESSION['kgatewayyaml::maxebs'];
            }
        }

        ///////////////////////////////////////////////////////////////////////
        // Misc methods
        ///////////////////////////////////////////////////////////////////////

        /**
         * Get KGatewayProfileYaml instance
         *
         * @return KGatewayProfileYaml
         */
        public function getKGatewayProfileYaml( )
        {
            if( is_null( self::$kgatewayprofileyaml ) )
            {
                require_once KCONFIG . '/classes/KGatewayProfileYaml.php';
                $this->setKGatewayProfileYaml( new KGatewayProfileYaml( ) );
                self::$kgatewayprofileyaml->setKGatewayYaml( $this );
            }
            return self::$kgatewayprofileyaml;
        }

        /**
         * Set the KGatewayProfileYaml instance
         *
         * @param KGatewayProfileYaml $instance
         */
        public function setKGatewayProfileYaml( KGatewayProfileYaml $instance )
        {
            self::$kgatewayprofileyaml = $instance;
        }

        ///////////////////////////////////////////////////////////////////////
        // NAPs manipulation methods
        ///////////////////////////////////////////////////////////////////////

        /**
         * Get nap
         * 
         * @param string $name Nap name
         * @return null|array
         */
        public function getNap( $name )
        {
            foreach( $this->yaml['NAPs'] as &$info )
            {
                if( $info['Name'] === $name )
                {
                    return $info;
                }
            }
            return null;
        }

        /**
         * Get all naps
         *
         * @return array
         */
        public function getAllNaps( )
        {
            return $this->yaml['NAPs'];
        }

        /**
         * Profile was renamed, check if need to update naps profiles
         *
         * @param string $name profile new name
         * @param string $oldName profile old name
         */
        public function renameNapsProfile( $name, $oldName )
        {
            trigger_error( "Renaming NAP profile {$oldName} to {$name}", E_USER_NOTICE );
            foreach( $this->yaml['NAPs'] as &$nap )
            {
                if( isset( $nap['Profile'] ) && $nap['Profile'] === $oldName )
                {
                    $nap['Profile'] = $name;
                }
            }
        }

        ///////////////////////////////////////////////////////////////////////
        // Routes manipulation methods
        ///////////////////////////////////////////////////////////////////////

        /**
         * Check if route exists
         *
         * @param string $name Route name
         * @return boolean
         */
        public function hasRoute( $name )
        {
            foreach( $this->yaml['Routes'] as &$info )
            {
                if( $info['Name'] === $name )
                {
                    return true;
                }
            }
            return false;
        }

        /**
         * Count defined routes
         *
         * @return int
         */
        public function countRoutes( )
        {
            return count( $this->yaml['Routes'] );
        }

        /**
         * Get route from YAML
         *
         * @param string $name Route name
         * @return null|array
         */
        public function getRoute( $name )
        {
            foreach( $this->yaml['Routes'] as &$info )
            {
                if( $info['Name'] === $name )
                {
                    return $info;
                }
            }
            return null;
        }

        /**
         * Get all routes
         *
         * @return array
         */
        public function getAllRoutes( )
        {
            return $this->yaml['Routes'];
        }

        /**
         * Set route to YAML
         *
         * If route exists, update it
         *
         * @param array $data Route info
         * @param string $oldName Route old name
         */
        public function setRoute( $data, $oldName = '' )
        {
            // duplicated route name
            if( $oldName != $data['Name'] && $this->hasRoute( $data['Name'] ) )
            {
                throw new KGatewayYamlException( 'gateway-route-error-already-exists' );
            }
            // update route
            if( empty( $oldName ) )
            {
                $this->yaml['Routes'][] = $data;
            }
            // add new route
            else
            {
                $notfound = true;
                foreach( $this->yaml['Routes'] as $idx => &$route )
                {
                    if( $oldName == $route['Name'] )
                    {
                        $route = $data;
                        $notfound = false;
                        break;
                    }
                }
                if( $notfound )
                {
                    throw new KGatewayYamlException( 'gateway-route-error-not-found' );
                }
            }
        }

        /**
         * Delete route
         *
         * @param string $name Route name
         */
        public function deleteRoute( $name )
        {
            foreach( $this->yaml['Routes'] as $idx => &$route )
            {
                if( $name == $route['Name'] )
                {
                    unset( $this->yaml['Routes'][$idx] );
                    return true;
                }
            }
            return false;
        }

        /**
         * Set routes order
         *
         * @param array $order Array of route names with the new order
         * @return boolean
         */
        public function setRoutesOrder( $order )
        {
            if( count( $order ) != count( $this->yaml['Routes'] ) )
            {
                throw new KGatewayYamlException( 'gateway-route-error-reorder-invalid-size' );
            }
            $tmp = array( );
            foreach( $order as $name )
            {
                $route = $this->getRoute( $name );
                if( is_null( $route ) )
                {
                    throw new KGatewayYamlException( 'gateway-route-error-reorder-invalid-name' );
                }
                else
                {
                    $tmp[] = $route;
                }
            }
            $this->yaml['Routes'] = &$tmp;
        }

        /**
         * Profile was renamed, check if need to update routes profiles
         *
         * @param string $name profile new name
         * @param string $oldName profile old name
         */
        public function renameRoutesProfile( $name, $oldName )
        {
            trigger_error( "Renaming ROUTE profile {$oldName} to {$name}", E_USER_NOTICE );
            foreach( $this->yaml['Routes'] as &$route )
            {
                if( isset( $route['DestinationProfile'] ) && $route['DestinationProfile'] === $oldName )
                {
                    $route['DestinationProfile'] = $name;
                }
            }
        }

        /**
         * Check if codec profile is being used
         *
         * @param string $name Codec profile name
         * @return boolean
         */
        public function isCodecProfileInUse( $name )
        {
            foreach( $this->yaml['Routes'] as &$route )
            {
                if( $route['CodecProfile'] === $name )
                {
                    return true;
                }
            }
            return false;
        }

        /**
         * Codec profile was renamed, check if need to update routes
         *
         * @param string $name Codec profile new name
         * @param string $oldName Codec profile old name
         */
        public function renameRoutesCodecProfile( $name, $oldName )
        {
            trigger_error( "Renaming ROUTE codec profile {$oldName} to {$name}", E_USER_NOTICE );
            foreach( $this->yaml['Routes'] as &$route )
            {
                if( $route['CodecProfile'] === $oldName )
                {
                    $route['CodecProfile'] = $name;
                }
            }
        }

        /**
         * Check if device is being used by any NAP
         *
         * @param string|integer $serial Device serial number
         * @return boolean
         */
        public function checkIfDeviceIsBeingUsedByAnyNap( $serial )
        {
            foreach( $this->yaml['NAPs'] as &$nap )
            {
                if( $nap['Type'] === 'Trunk' )
                {
                    foreach( $nap['Links'] as &$l )
                    {
                        // serial will always be the first part
                        $_serial = explode( '.', $l );
                        if( is_array( $_serial ) && count( $_serial ) > 0 && $_serial[0] === $serial )
                        {
                            return true;
                        }
                    }
                }
            }
            return false;
        }

        /**
         * Check if the route has call analyzer enabled by its profile
         * 
         * Note: The profile is checked recursively
         * 
         * @param string $name Route name
         * @return boolean
         */
        public function routeHasCallAnalyzerEnabled( $name )
        {
            $route = $this->getRoute( $name );
            
            if( is_null( $route ) )
            {
                throw new KGatewayYamlException( 'gateway-route-error-not-found' );
            }

            // WARNING: false means profile not set, null (returned from
            // getProfile) means profile not found
            $profile = isset( $route['DestinationProfile'] ) && $route['DestinationProfile'] ? $this->getKGatewayProfileYaml( )->getProfile( $route['DestinationProfile'] ) : false;
            if( $profile === false ) 
            {
                $nap = $this->getNap( $route['DestinationNAP'] );
                if( is_null( $nap ) )
                {
                    throw new KGatewayYamlException( 'gateway-nap-error-not-found' );
                }

                $profile = isset( $nap['Profile'] ) && $nap['Profile'] ? $this->getKGatewayProfileYaml()->getProfile( $nap['Profile'] ) : false;
            }

            if( $profile === false )
            {
                $profile = $this->getKGatewayProfileYaml()->getDefaultProfile();
            }

            if( is_null( $profile ) )
            {
                throw new KGatewayYamlException( 'gateway-route-error-profile-not-found' );
            }

            return isset( $profile['CallAnalyzer'] ) && isset( $profile['CallAnalyzer']['Enabled'] ) && $profile['CallAnalyzer']['Enabled'];
        }

        ///////////////////////////////////////////////////////////////////////
        // Gateway capabilities
        ///////////////////////////////////////////////////////////////////////

        /**
         * Get gateway model
         *
         * @return integer
         */
        public function getModel( )
        {
            return $this->model;
        }

        /**
         * Check if gateway model is ...
         *
         * @param integer $model
         * @return true if it is the desired model
         */
        public function isModel( $model )
        {
            return $this->model === $model;
        }

        /**
         * Get maximum EBS supported
         *
         * @return integer
         */
        public function getMaxEbs( )
        {
            return $this->maxebs;
        }

        ///////////////////////////////////////////////////////////////////////
        // CDR manipulation methods
        ///////////////////////////////////////////////////////////////////////

        /**
         * Check if CDR is enabled
         *
         * @return boolean
         */
        public function isCDREnabled( )
        {
            return isset( $this->yaml['CDR']['Enabled'] ) ? $this->yaml['CDR']['Enabled'] : true;
        }

        /**
         * Get CDR data
         *
         * @return array
         */
        public function getCDR( )
        {
            return $this->yaml['CDR'];
        }

        /**
         * Set CDR data
         *
         * @param array $data CDR data
         */
        public function setCDR( $data )
        {
            // always keep BasePath key value!
            $currentData = $this->getCDR( );
            $data['BasePath'] = $currentData['BasePath'];
            $this->yaml['CDR'] = $data;
        }

        ///////////////////////////////////////////////////////////////////////
        // Audit manipulation methods
        ///////////////////////////////////////////////////////////////////////

        /**
         * Check if audit is enabled
         *
         * @return boolean
         */
        public function isAuditEnabled( )
        {
            $ts = $this->getAuditEndAsUnixTimestamp( );
            if( $ts !== null && $ts > time( ) )
            {
                return true;
            }
            return false;
        }

        /**
         * Check if route is being audited
         *
         * @param string $name Route name
         * @return boolean
         */
        public function isRouteAudited( $name )
        {
            return isset( $this->yaml['Audit']['Routes'] ) && in_array( $name, $this->yaml['Audit']['Routes'] );
        }

        /**
         * Set audit parameters
         *
         * @param array $data Audit data
         */
        public function enableAudit( $data )
        {
            $data['Start'] = strftime( self::$audittimefmt );
            $this->yaml['Audit'] = $data;
        }

        /**
         * Set audit Start time to empty (stop audit)
         */
        public function disableAudit( )
        {
            $this->yaml['Audit']['Start'] = '';
        }

        /**
         * Get audit parameters
         *
         * @return array
         */
        public function getAudit( )
        {
            return isset( $this->yaml['Audit'] ) ? $this->yaml['Audit'] : null;
        }

        /**
         * Get audit start date as UNIX timestamp
         *
         * @return integer UNIX timestamp or null if an error occured
         */
        public function getAuditStartAsUnixTimestamp( )
        {
            if( empty( $this->yaml['Audit']['Start'] ) )
            {
                return null;
            }
            $t = strptime( $this->yaml['Audit']['Start'], self::$audittimefmt );
            if( $t === false )
            {
                return null;
            }
            $t = mktime( $t['tm_hour'], $t['tm_min'], $t['tm_sec'], $t['tm_mon'] + 1, $t['tm_mday'], $t['tm_year'] + 1900 );
            if( $t === false )
            {
                return null;
            }
            return $t;
        }

        /**
         * Get audit end date as UNIX timestamp
         *
         * @return integer UNIX timestamp or null if an error occured
         */
        public function getAuditEndAsUnixTimestamp( )
        {
            $start = $this->getAuditStartAsUnixTimestamp( );
            if( $start === null )
            {
                return null;
            }
            return $start + $this->yaml['Audit']['End'];
        }

        ///////////////////////////////////////////////////////////////////////
        // Codec profile manipulation methods
        ///////////////////////////////////////////////////////////////////////

        /**
         * Check if codec profile exists
         *
         * @param string $name Codec profile name
         * @return boolean
         */
        public function hasCodecProfile( $name )
        {
            foreach( $this->yaml['CodecProfiles'] as &$profile )
            {
                if( $profile['Name'] === $name )
                {
                    return true;
                }
            }
            return false;
        }

        /**
         * Count defined codec profiles
         *
         * @return int
         */
        public function countCodecProfiles( )
        {
            return count( $this->yaml['CodecProfiles'] );
        }

        /**
         * Get codec profile
         *
         * @param string $name Codec profile name
         * @return array
         */
        public function getCodecProfile( $name )
        {
            $found = false;
            foreach( $this->yaml['CodecProfiles'] as &$profile )
            {
                if( $name === $profile['Name'] )
                {
                    $found = true;
                    break;
                }
            }

            if( !$found )
            {
                return null;
            }

            $this->checkCodecProfile( $profile );
            return $profile;
        }

        /**
         * Get all codec profiles
         *
         * @return array
         */
        public function getAllCodecProfiles( )
        {
            foreach( $this->yaml['CodecProfiles'] as &$profile )
            {
                $this->checkCodecProfile( $profile );
            }

            return $this->yaml['CodecProfiles'];
        }

        /**
         * Set codec profile
         *
         * @param array $data Codec profile info
         * @param string $oldName Codec profile old name
         */
        public function setCodecProfile( $data, $oldName = '' )
        {
            // duplicated codec profile name
            if( $oldName != $data['Name'] && $this->hasCodecProfile( $data['Name'] ) )
            {
                throw new KGatewayYamlException( 'gateway-codec-profile-save-error-duplicated' );
            }
            // new codec profile
            if( empty( $oldName ) )
            {
                $this->yaml['CodecProfiles'][] = $data;
            }
            // update codec profile
            else
            {
                $notfound = true;
                foreach( $this->yaml['CodecProfiles'] as $idx => &$profile )
                {
                    if( $oldName === $profile['Name'] )
                    {
                        if( $profile['Name'] != $data['Name'] )
                        {
                            $this->renameRoutesCodecProfile( $data['Name'], $oldName );
                        }
                        $profile = $data;
                        $notfound = false;
                        break;
                    }
                }
                if( $notfound )
                {
                    throw new KGatewayYamlException( 'gateway-codec-profile-error-not-found' );
                }
            }
        }

        /**
         * Delete codec profile
         *
         * @param string $name Codec profile name
         */
        public function deleteCodecProfile( $name )
        {
            if( $this->isCodecProfileInUse( $name ) )
            {
                throw new KGatewayYamlException( 'gateway-codec-profile-delete-error-inuse' );
            }

            foreach( $this->yaml['CodecProfiles'] as $idx => $profile )
            {
                if( $profile['Name'] === $name )
                {
                    unset( $this->yaml['CodecProfiles'][$idx] );
                    break;
                }
            }
        }

        /**
         * Check the profile's codec list
         *
         * @param array $profile The profile.
         */
        protected function checkCodecProfile( &$profile )
        {
            // codec G729 will enable G729B, but we don't support it, so, rename
            // G729 and G729B to G729A
            foreach( $profile['CodecList'] as $idx => $codec )
            {
                if( in_array( $codec, self::$g729b ) )
                {
                    trigger_error( "Renamed CODEC from {$codec} to G729A, refrenced by profile {$profile['Name']}", E_USER_NOTICE );
                    $profile['CodecList'][$idx] = 'G729A';
                }
            }
        }

    }
