<?php
    require_once KCONFIG . '/classes/classKGatewayUtil.php';
    require_once KCONFIG . '/classes/KGatewayYaml.php';

    $AjaxFunctions['showNAPsGW'] = 'showNAPsGW';
    $AjaxFunctions['newNAP'] = 'newNAP';
    $AjaxFunctions['printNAPType'] = 'printNAPType';
    $AjaxFunctions['saveNAP'] = 'saveNAP';
    $AjaxFunctions['removeNAP'] = 'removeNAP';
    $AjaxFunctions['editNAP'] = 'editNAP';

    function showNAPsGW( )
    {
        $app = KSystem::getInstance( );

        $kyaml = new KGatewayYaml( );
        $yaml = $kyaml->getYaml( );
        $buffer = '';

        $buffer .= "<fieldset><legend>{$app->translate( 'gateway-nap' )}</legend>";
        $buffer .= "<div id='NAPsDivForm'>";
        $buffer .= "<input type='button' value='{$app->translate( 'gateway-nap-new' )}' onClick='newNAP();' /><br /><br />";

        if( sizeof((array_values( $yaml['NAPs'] ))) > 0 )
        {

            $buffer .= "<table id='NAPsTable' class='gateway-table'><thead><tr>";
            $buffer .= "<th>{$app->translate( 'name' )}</th>";
            $buffer .= "<th>{$app->translate( 'type' )}</th>";
            $buffer .= "<th>{$app->translate( 'gateway-profile' ) }</th>";
            $buffer .= "<th class='gateway-table-options'>{$app->translate( 'options' )}</th></tr></thead><tbody>";
            foreach( $yaml['NAPs'] as $nap )
            {
                $p = isset( $nap['Profile'] ) && $nap['Profile'] ? $nap['Profile'] : "<i>{$app->translate( 'gateway-nap-use-default-profile' )}</i>";
                $ename = urlencode( $nap['Name'] );
                $buffer .= "<tr>";
                $buffer .= "<td>{$nap['Name']}</td>";
                $buffer .= "<td>{$nap['Type']}</td>";
                $buffer .= "<td>{$p}</td>";
                $buffer .= "<td class='gateway-table-options'><a href='#' onClick=\"editNAP('{$ename}');\"><img border='0' src='/imagens/editark.gif' title='{$app->translate( 'edit' )}' /></a><a href='#' onClick=\"removeNAP('{$ename}');\"><img border='0' src='/imagens/lixeira.gif'  title='{$app->translate( 'delete' )}' /></a></td>";
                $buffer .= "</tr>";
            }
            $buffer .= "</tbody></table>";
        }
        else
        {
            $buffer .= $app->translate( 'gateway-nap-empty-list' );
        }

        $buffer .= '</div>';
        $buffer .= '</fieldset>';

        return $buffer;
    }

    //TODO: Validate all incomming data
    function saveNAP( )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );

        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-nap-save-error' ) );

        try
        {
            $kyaml = new KGatewayYaml( );
            $yaml = $kyaml->getYaml( );

            $renamed = false;
            $duplicated = false;
            $duplicatedRegister = false;
            // if true, the yaml can be saved, so change to false to report
            // errors
            $canSave = true;
            $new = strlen( $_POST['oldName'] ) == 0;
            $myname = $_POST['Name'];

            if( !$new && $_POST['oldName'] != $_POST['Name'] )
            {
                $renamed = true;
                $myname = $_POST['oldName'];
            }
            if( $new || $renamed )
            {
                // if it is new or renamed, check if $_POST['name'] already
                // exists -- duplicate key check
                foreach( $yaml['NAPs'] as &$_nap )
                {
                    if( $_nap['Name'] == $_POST['Name'] )
                    {
                        $duplicated = true;
                        $canSave = false;
                        break;
                    }
                }
            }
            if( isset( $_POST['Register'] ) && $_POST['Register'] == 'true' )
            {
                foreach( $yaml['NAPs'] as &$_nap )
                {
                    if( $_nap['Name'] == $myname || $_nap['Type'] != 'SIP' || !$_nap['Register'] )
                    {
                        continue;
                    }
                    if( $_nap['Domain'] == $_POST['Domain'] && $_nap['DomainPort'] == $_POST['DomainPort'] && $_nap['AuthorizationUser'] == $_POST['AuthorizationUser'] )
                    {
                        $duplicatedRegister = true;
                        $canSave = false;
                        break;
                    }
                }
            }
            if( $duplicated )
            {
                $reply['message'] = $app->translate( 'gateway-nap-save-error-duplicated' );
            }
            elseif( $duplicatedRegister )
            {
                $reply['message'] = $app->translate( 'gateway-nap-save-error-duplicated-register' );
            }
            else
            {
                $missing = true;
                if( $new )
                {
                    // append the new
                    $nap = array( 'Name' => $_POST['Name'], 'Type' => $_POST['Type'] );
                    $yaml['NAPs'][] = &$nap;
                    $missing = false;
                }
                else if( $renamed )
                {
                    // update
                    foreach( $yaml['NAPs'] as &$nap )
                    {
                        if( $nap['Name'] == $_POST['oldName'] )
                        {
                            $nap['Name'] = $_POST['Name'];
                            $nap['Type'] = $_POST['Type'];
                            $missing = false;
                            break;
                        }
                    }
                    if( !$missing )
                    {
                        // update any route that referrer to the old name
                        foreach( $yaml['Routes'] as &$_route )
                        {
                            if( $_route['OriginNAP'] == $_POST['oldName'] )
                            {
                                $_route['OriginNAP'] = $nap['Name'];
                            }
                            if( $_route['DestinationNAP'] == $_POST['oldName'] )
                            {
                                $_route['DestinationNAP'] = $nap['Name'];
                            }
                        }
                    }
                }
                else
                {
                    // update *only*
                    foreach( $yaml['NAPs'] as &$nap )
                    {
                        if( $nap['Name'] == $_POST['Name'] )
                        {
                            $nap['Type'] = $_POST['Type'];
                            $missing = false;
                            break;
                        }
                    }
                }

                if( $missing )
                {
                    $reply['message'] = $app->translate( 'gateway-nap-error-not-found' );
                    $canSave = false;
                }
                else
                {
                    if( isset( $_POST['Profile'] ) )
                    {
                        $nap['Profile'] = $_POST['Profile'];
                    }
                    elseif( isset( $nap['Profile'] ) )
                    {
                        unset( $nap['Profile'] );
                    }
                    // type specific data
                    switch( $nap['Type'] )
                    {
                        case 'SIP':
                            $nap['Register'] = $_POST['Register'] == 'true';
                            $nap['Domain'] = $_POST['Domain'];
                            $nap['DomainPort'] = $_POST['DomainPort'];
                            $nap['DomainUseIpPacketAddress'] = $_POST['DomainUseIpPacketAddress'] == 'true';
                            $nap['UseCalledFromRequestURI'] = $_POST['UseCalledFromRequestURI'] == 'true';
                            $nap['AuthorizationUser'] = $_POST['AuthorizationUser'];
                            $nap['Expires'] = $_POST['Expires'];
                            $nap['Proxy'] = $_POST['Proxy'];
                            $nap['ProxyPort'] = $_POST['ProxyPort'];
                            $nap['Username'] = $_POST['Username'];
                            $nap['Password'] = $_POST['Password'];
                            break;
                        case 'Trunk':
                            $nap['Links'] = array( );
                            foreach( $_POST['Links'] as $link )
                            {
                                $nap['Links'][] = str_replace( '-', '.', $link );
                            }
                            break;
                        /*
                         case 'GSM':
                         case 'FXO':
                         $nap['Channels'] = array( );
                         foreach( $_POST['Channels'] as $channel )
                         {
                         $nap['Channels'][] = str_replace( '-', '.', $channel );
                         }
                         break;
                         case 'FXS':
                         $nap['Branches'] = array( );
                         foreach( $_POST['Branches'] as $dev=>$branch )
                         {
                         $dev = str_replace( '-', '.', $dev );
                         $nap['Branches'][$dev] = $branch;
                         }
                         break;
                         */
                        default:
                            $canSave = false;
                            break;
                    }
                }

                if( $canSave )
                {
                    $kyaml->setYaml( $yaml );
                    //$kyaml->saveYaml( );
                    $kyaml->save( );
                    $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-nap-saved' ) );
                }
            }
        }
        catch( Exception $e )
        {
            $reply['message'] = $app->translate( $e->getMessage( ));
        }
        return JSONencode( $reply );
    }

    function removeNAP( $_REQUEST )
    {
        require_once KROOT . '/json_util.php';
        $app = KSystem::getInstance( );

        $reply = array( 'success' => false, 'message' => $app->translate( 'gateway-nap-delete-error' ) );

        $name = isset( $_POST['name'] ) ? urldecode( $_POST['name'] ) : null;
        if( !is_null( $name ) )
        {
            try
            {
                $kyaml = new KGatewayYaml( );
                $yaml = $kyaml->getYaml( );
                foreach( $yaml['NAPs'] as $idx => $nap )
                {
                    if( $nap['Name'] == $name )
                    {
                        $inUse = false;
                        foreach( $yaml['Routes'] as $route )
                        {
                            if( $route['OriginNAP'] == $nap['Name'] || $route['DestinationNAP'] == $nap['Name'] )
                            {
                                $inUse = true;
                                break;
                            }
                        }
                        if( $inUse )
                        {
                            $reply['message'] = $app->translate( 'gateway-nap-delete-error-inuse' );
                        }
                        else
                        {
                            unset( $yaml['NAPs'][$idx] );
                            $kyaml->setYaml( $yaml );
                            //$kyaml->saveYaml( );
                            $kyaml->save( );

                            $reply = array( 'success' => true, 'message' => $app->translate( 'gateway-nap-deleted' ) );
                        }
                        break;
                    }
                }
            }
            catch( Exception $e )
            {
                $reply['message'] = $app->translate( $e->getMessage( ) );
            }
        }
        return JSONencode( $reply );
    }

    function newNAP( $_REQUEST )
    {
        require_once KCONFIG . '/classes/KGatewayYaml.php';

        return printNAPForm( new KGatewayYaml( ) );
    }

    function editNAP( )
    {
        $name = isset( $_POST['name'] ) ? urldecode( $_POST['name'] ) : null;
        $app = KSystem::getInstance( );

        if( !is_null( $name ) )
        {
            $kyaml = new KGatewayYaml( );
            $yaml = $kyaml->getYaml( );
            foreach( $yaml['NAPs'] as &$nap )
            {
                if( $nap['Name'] == $name )
                {
                    return printNAPForm( $kyaml, $nap );
                }
            }
        }
        return $app->translate( 'gateway-nap-error-not-found' );
    }

    function printNAPForm( KGatewayYaml $yaml, $data = array() )
    {
        $app = KSystem::getInstance( );
        $profiles = $yaml->getKGatewayProfileYaml( );

        $_napName = array_key_exists( 'Name', $data ) ? htmlspecialchars( $data['Name'], ENT_QUOTES ) : '';

        $buffer = '';
        $buffer .= "<input type='hidden' value='{$_napName}' id='gateway-nap-old-name' />";
        $buffer .= "<table class='gateway-table-form'>";
        $buffer .= "<tr><td class='label'><label for='gateway-nap-name'>{$app->translate( 'NAPName' )}</label>:</td><td><input type='text' value='{$_napName}' id='gateway-nap-name' /></td></tr>";
        $buffer .= "<tr><td class='label'><label for='gateway-nap-profile'>{$app->translate( 'gateway-profile' )}</label>:</td><td><select id='gateway-nap-profile' name='Profile'>";
        $_profileName = isset( $data['Profile'] ) ? $data['Profile'] : null;
        $buffer .= "<option value=''>{$app->translate( 'gateway-nap-use-default-profile' )}</option>";
        foreach( $profiles->getAllProfiles() as $profile )
        {
            $s = $_profileName === $profile['Name'] ? ' selected' : '';
            $profileName = htmlspecialchars( $profile['Name'] );
            $buffer .= "<option value='{$profileName}'{$s}>{$profileName}</option>";
        }
        $buffer .= "</select></td></tr>";
        $buffer .= "<tr><td class='label'><label for='gateway-nap-type'>{$app->translate( 'Type' )}</label>:</td><td><select id='gateway-nap-type' onChange='changeNAPType();'>";
        $types = getNAPTypes( $yaml );
        $buffer .= "<option value='<SELECT>'>{$app->translate( 'Select' )}</option>";

        foreach( $types as $t )
        {
            if( array_key_exists( 'Type', $data ) && $t == $data['Type'] )
            {
                $buffer .= "<option value='{$t}' selected='selected'>{$t}</option>";
            }
            else
            {
                $buffer .= "<option value='{$t}'>{$t}</option>";
            }
        }
        $buffer .= '</select></td></tr></table><br />';
        $buffer .= '<div id="gateway-nap"></div>';
        $buffer .= "<br /><input type='button' onclick='saveNAP();' value='{$app->translate( 'save' )}' /><input type='button' onclick='backNAPs();' value='{$app->translate( 'back' )}' />";

        return $buffer;
    }

    function printNAPType( )
    {
        $app = KSystem::getInstance( );
        $type = isset( $_POST['type'] ) ? $_POST['type'] : NULL;

        if( !isset( $type ) )
            return;

        $yaml = new KGatewayYaml( );
        $_yaml = $yaml->getYaml( );

        $nap = null;
        $name = isset( $_POST['name'] ) ? $_POST['name'] : null;

        if( $name )
        {
            $nap = searchNAPValue( $name, $_yaml );
        }
        if( is_null( $nap ) )
        {
            $nap = array( );
        }

        switch($type)
        {
            case 'Trunk':
                return printNewNAPTrunk( $nap, $_yaml );
                break;
            case 'SIP':
                return printNewNAPSIP( $nap, $_yaml );
                break;
            /*
             case 'GSM':
             return printNewNAPGSM( $nap, $_yaml );
             break;
             case 'FXO':
             return printNewNAPFXO( $nap, $_yaml );
             break;
             case 'FXS':
             return printNewNAPFXS( $nap, $_yaml );
             break;
             case 'FXSGroup':
             return printNewNAPFXSGroup( $nap, $_yaml );
             break;
             */
            case '<SELECT>':
                return $app->translate( 'gateway-nap-select-type' );
            default:
                return $app->translate( 'gateway-nap-unsupported-type' );
                break;
        }
        return $form_buffer;
    }

    function printNewNAPGSM( $nap, $yaml )
    {
        global $sistema;
        $app = KSystem::getInstance( );

        $buffer = '';

        $devGSM = $sistema->getSpecificDevice( 'GSM' );

        $buffer .= "{$app->translate( 'NAPChannels' )}:<br /><table border='0'>";

        $_mylinks = array( );
        if( array_key_exists( 'Channels', $nap ) )
        {
            // OUTCH!!! YAML CAST DOTTED ELEMENTS TO FLOAT!!!
            // This ugly cast is to ensure that link ids (device.link)
            // are in string form and not as float
            foreach( $nap['Channels'] as $link )
            {
                $_mylinks[] = "{$link}";
            }
        }
        $_napName = array_key_exists( 'Name', $nap ) ? $nap['Name'] : '';

        foreach( $devGSM as $ch )
        {
            $buffer .= '<tr>';
            $buffer .= '<td>';
            $buffer .= '<table>';
            $buffer .= '<tr>';
            $buffer .= "<td>Serial: {$ch}</td>";
            $buffer .= '</tr>';

            $buffer .= "<tr><td>{$app->translate( 'SIMCard0' )}</td></tr>";
            $buffer .= "<tr><td>{$app->translate( 'SIMCard1' )}</td></tr>";
            $buffer .= '</table>';
            $buffer .= '</td>';

            for( $i = 0; $i < 16; $i++ )
            {
                // html id
                $channel0Id = "{$ch}-{$i}-0";
                $channel1Id = "{$ch}-{$i}-1";
                // device id
                $channel0IdDev = "{$ch}.{$i}.0";
                $channel1IdDev = "{$ch}.{$i}.1";
                $buffer .= "<td>";
                $buffer .= "<table>";
                $buffer .= "<tr>";
                $buffer .= "<td>";
                $buffer .= "<table>";
                $buffer .= "<tr><td>{$i}</td></tr>";
                $buffer .= "<tr><td>";
                if( in_array( $channel0IdDev, $_mylinks ) )
                {
                    $extra = ' checked=\'true\'';
                }
                elseif( _isGSMChannelInUse( $yaml, $channel0IdDev ) )
                {
                    $extra = ' disabled=\'disabled\'';
                }
                else
                {
                    $extra = '';
                }
                $buffer .= "<input type='checkbox' id='{$channel0Id}' class='gateway-nap-gsm-channel' {$extra}/>";
                $buffer .= "</td></tr>";
                $buffer .= "<tr><td>";
                if( in_array( $channel1IdDev, $_mylinks ) )
                {
                    $extra = ' checked=\'true\'';
                }
                elseif( _isGSMChannelInUse( $yaml, $channel1IdDev ) )
                {
                    $extra = ' disabled=\'disabled\'';
                }
                else
                {
                    $extra = '';
                }
                $buffer .= "<input type='checkbox' id='{$channel1Id}' class='gateway-nap-gsm-channel' {$extra}/>";
                $buffer .= "</td></tr>";
                $buffer .= "</table>";
                $buffer .= "</td>";
                $buffer .= "</tr>";
                $buffer .= "</table>";
                $buffer .= "</td>";
            }
        }
        $buffer .= '</tr>';
        $buffer .= '</table>';

        return $buffer;
    }

    function printNewNAPFXO( $nap, $yaml )
    {
        global $sistema;
        $app = KSystem::getInstance( );

        $buffer = '';
        $devFXO = $sistema->getSpecificDevice( 'FXO' );

        $buffer .= "{$app->translate( 'NAPChannels' )}<br /><table border='0'>";

        $_mylinks = array( );
        if( array_key_exists( 'Channels', $nap ) )
        {
            // OUTCH!!! YAML CAST DOTTED ELEMENTS TO FLOAT!!!
            // This ugly cast is to ensure that link ids (device.link)
            // are in string form and not as float
            foreach( $nap['Channels'] as $link )
            {
                $_mylinks[] = "{$link}";
            }
        }

        $_napName = array_key_exists( 'Name', $nap ) ? $nap['Name'] : '';

        foreach( $devFXO as $dev )
        {
            $buffer .= "<tr><td>Serial: {$dev}</td>";
            for( $i = 0; $i < 12; $i++ )
            {
                // html id
                $channelId = "{$dev}-{$i}";
                // device id
                $channelIdDev = "{$dev}.{$i}";
                if( in_array( $channelIdDev, $_mylinks ) )
                {
                    $extra = ' checked=\'true\'';
                }
                elseif( _isFXOChannelInUse( $yaml, $channelIdDev ) )
                {
                    $extra = ' disabled=\'disabled\'';
                }
                else
                {
                    $extra = '';
                }
                $buffer .= "<td>$i<br/><input id='{$channelId}' class='gateway-nap-fxo-channel' type='checkbox' {$extra}/></td>";
            }
        }
        $buffer .= '</tr>';
        $buffer .= '</table>';

        return $buffer;
    }

    function printNewNAPTrunk( $nap, $yaml )
    {
        global $sistema;
        $app = KSystem::getInstance( );
        $buffer = '';

        $configDir = $app->getConfigDir( );
        $devYaml = new KYaml( "{$app->getConfigDir()}/devices.yaml" );

        $devE1 = $sistema->getSpecificDevice( 'E1' );

        $_mylinks = array( );
        if( array_key_exists( 'Links', $nap ) )
        {
            // OUTCH!!! YAML CAST DOTTED ELEMENTS TO FLOAT!!!
            // This ugly cast is to ensure that link ids (device.link)
            // are in string form and not as float
            foreach( $nap['Links'] as $link )
            {
                $_mylinks[] = "{$link}";
            }
        }
        $_napName = array_key_exists( 'Name', $nap ) ? $nap['Name'] : '';

        foreach( $devE1 as $e1 )
        {
            $dev = $devYaml->getValue( $e1 );
            $linksCount = sizeof( $dev['Links'] );

            $buffer .= "<fieldset><legend>{$app->translate( 'Device' )}: {$e1}</legend><table border='0' class='gateway-nap-trunk-device'>";

            for( $i = 0; $i < $linksCount; $i++ )
            {
                $channelsAllocatedByAnotherNap = 0;
                $channelsAllocatedByCurrentNap = 0;
                // yaml node reference
                $link = &$dev['Links'][$i][$i];
                // html id
                $idLink = "{$e1}-{$i}";
                // device id
                $idLinkDev = "{$e1}.{$i}";

                $buff = "<div class='gateway-nap-trunk-channels' id='channels-link-{$idLink}'><ul>";

                for( $l = 0; $l < 30; $l++ )
                {
                    $idChannel = "{$idLink}-{$l}";
                    $idChannelDev = "{$idLinkDev}.{$l}";

                    if( in_array( $idChannelDev, $_mylinks, true ) )
                    {
                        $channelsAllocatedByCurrentNap++;
                        $extra = ' checked=\'true\'';
                    }
                    elseif( _isTrunkChannelInUse( $yaml, $idChannelDev ) )
                    {
                        $channelsAllocatedByAnotherNap++;
                        $extra = ' disabled=\'disabled\'';
                    }
                    else
                    {
                        $extra = '';
                    }
                    $buff .= "<li><label for='{$idChannel}'>{$l}</label><br /><input id='{$idChannel}' class='gateway-nap-trunk-link-channel' type='checkbox' {$extra}/></li>";
                    if( $l == 14 )
                    {
                        $buff .= "</ul><ul>";
                    }
                }
                $buff .= "</ul></div>";

                $name = isset( $link['Name'] ) ? "{$e1}.{$i}: {$link['Name']}" : "{$e1}.{$i}:";

                if( !in_array( $idLinkDev, $_mylinks, true ) && ( _isTrunkChannelInUse( $yaml, $idLinkDev )) || $channelsAllocatedByAnotherNap == 30 )
                {
                    $options = "<span class='gateway-nap-fully-allocated'>{$app->translate( 'gateway-nap-trunk-fully-allocated' )}</span>";
                }
                else
                {
                    $options = "<select id='{$idLink}' name='link-{$idLink}'>";
                    foreach( array( 'unassigned', 'full', 'partial' ) as $opt )
                    {
                        $select = '';
                        if( ($opt == 'full' && in_array( $idLinkDev, $_mylinks, true )) || ($opt == 'partial' && $channelsAllocatedByCurrentNap > 0) )
                        {
                            $select = 'selected=\'selected\'';
                        }
                        // hide full option if has any channel allocated by
                        // another NAP
                        elseif( $opt == 'full' && $channelsAllocatedByAnotherNap > 0 )
                        {
                            continue;
                        }
                        elseif( $opt == 'unassigned' && !in_array( $idLinkDev, $_mylinks, true ) && $channelsAllocatedByCurrentNap == 0 )
                        {
                            $select = 'selected=\'selected\'';
                        }
                        $optid = "gateway-nap-trunk-allocate-{$opt}";
                        $options .= "<option value='{$opt}' {$select}>{$app->translate( $optid )}</option>";
                    }
                    $options .= '</select>';
                }

                $buffer .= "<tr><td class='width150'><label for='{$idLink}'>{$name}</label></td><td>{$options}<br />{$buff}</td></tr>";
            }
            $buffer .= '</table></fieldset><br />';
        }

        return $buffer;
    }

    function printNewNAPFXS( $nap, $yaml )
    {
        global $sistema;
        $app = KSystem::getInstance( );

        $buffer = '';
        $devFXS = $sistema->getSpecificDevice( 'FXS' );

        $buffer .= "{$app->translate( 'Branches' )}:<br /><table border='0'>";

        $_mylinks = array( );
        if( array_key_exists( 'Branches', $nap ) )
        {
            // OUTCH!!! YAML CAST DOTTED ELEMENTS TO FLOAT!!!
            // This ugly cast is to ensure that link ids (device.link)
            // are in string form and not as float
            foreach( $nap['Branches'] as $device => $branch )
            {
                $_mylinks["{$device}"] = $branch;
            }
        }

        foreach( $devFXS as $fxs )
        {
            $buffer .= '<tr>';
            $buffer .= '<td>';
            $buffer .= "<table>";
            $buffer .= '<tr>';
            $buffer .= "<td>Serial: {$fxs}<br>";
            $buffer .= "<span class='cursorHand' onclick='autoCompleteFXS( {$fxs} );'><img src='/imagens/seta3.png' border='0' /></span>";
            $buffer .= "<span class='cursorHand' onclick='cleanFXS( {$fxs} );'><img src='/imagens/broom2.jpg' border='0' /></span>";
            $buffer .= "</td>";
            $buffer .= '</tr>';
            $buffer .= '</table>';
            $buffer .= '</td>';
            $buffer .= '<td>';
            $buffer .= "<table id='branches-{$fxs}' border='0'><tr>";
            for( $i = 0; $i < 24; $i++ )
            {
                // html id
                $branchId = "{$fxs}-{$i}";
                // device id
                $branchIdDev = "{$fxs}.{$i}";

                if( array_key_exists( $branchIdDev, $_mylinks ) )
                {
                    $extra = " value='{$_mylinks[$branchIdDev]}'";
                }
                elseif( _isFXSChannelInUse( $yaml, $branchIdDev ) )
                {
                    $extra = ' disabled=\'disabled\'';
                }
                else
                {
                    $extra = ' value=\'\'';
                }

                if( $i > 0 && $i % 8 == 0 )
                {
                    $tr = '</tr><tr>';
                }
                else
                {
                    $tr = '';
                }
                $buffer .= "{$tr}<td width='40'>{$i}: <input id='{$branchId}' class='gateway-nap-fxs-branch' type='text' size='4' onkeydown='return onlyIntegerNumbers(event);' {$extra}/></td>";
            }
            $buffer .= '</tr></table></td></tr>';
        }
        $buffer .= '</table>';

        return $buffer;
    }

    //TODO: port this function to work in the same way as the other printNewNAP*
    function printNewNAPFXSGroup( $nap, $yaml )
    {
        return 'TODO: FIXME';
        global $sistema;
        $buffer = '';

        $buffer .= $sistema->retTranslate( 'NAPChannels' ) . ':<br/><table border="0">';
        $buffer .= '<tr><td><table>';
        $buffer .= '<tr>';

        $nap = getNAPFXS( );
        if( $nap != '' )
        {
            $ramais = array( );
            $seriais = '';

            if( sizeof( $nap['Branches'] ) > 0 )
            {
                for( $i = 0; $i < sizeof( $nap['Branches'] ); $i++ )
                {
                    $tmp = array_values( $nap['Branches'][$i] );
                    $ramais[] = $tmp[0];
                }
                $ctrl = 0;
                $seriais = '';
                foreach( $ramais as $r )
                {
                    $seriais .= "$r|";
                    $disabled = verificaSeCanalJaUtilizado( 'FXSGroup', "$r" ) ? 'disabled' : '';
                    $buffer .= "<td>$r<input $disabled id='$r' type='checkbox' /></td>";
                    if( $ctrl == 7 )
                    {
                        $buffer .= '</tr>';
                        $ctrl = 0;
                    }
                    else
                        $ctrl++;
                }
            }
            else
                $buffer .= "<td>" . $sistema->retTranslate( 'noFXSBranches' ) . "</td>";
            $buffer .= '</table></td></tr>';
            $buffer .= '</table>';

            $seriais = substr( $seriais, 0, strlen( $seriais ) - 1 );
            // clear the last pipe
            $buffer .= "<input id='seriais' type='hidden' value='$seriais' />";
            if( sizeof( $nap['Branches'] ) > 0 )
                $buffer .= "</br><input type='button' onclick='saveFXSGroupNAP();' value='" . $sistema->retTranslate( 'save' ) . "' />";
            $buffer .= "<input type='button' onclick='backNAPs();' value='" . $sistema->retTranslate( 'back' ) . "' />";
        }

        return $buffer;
    }

    function printNewNAPSIP( $nap, $yaml )
    {
        $app = KSystem::getInstance( );
        if( is_null( $nap ) || count( $nap ) == 0 )
        {
            $nap = array( 'Register' => false, 'Username' => '', 'Domain' => '', 'DomainPort' => 5060, 'DomainUseIpPacketAddress' => false, 'Proxy' => '', 'ProxyPort' => '', 'AuthorizationUser' => '', 'Password' => '', 'Expires' => '', 'UseCalledFromRequestURI' => false );
        }

        $buffer = '';

        $buffer .= '<table class="textAlignLeft;">';

        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-domain'>{$app->translate( 'gateway-nap-sip-domain' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-domain' type='text' value='{$nap['Domain']}' /></td>";
        $buffer .= '</tr>';

        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-domain-port'>{$app->translate( 'gateway-nap-sip-domain-port' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-domain-port' type='text' value='{$nap['DomainPort']}' /></td>";
        $buffer .= '</tr></table><br  />';

        $buffer .= "<fieldset><legend>{$app->translate( 'options' )}</legend>";
        $checked = $nap['DomainUseIpPacketAddress'] ? ' checked=\'checked\'' : '';
        $buffer .= "<input id='gateway-nap-sip-domain-use-ip-packet-address' name='DomainUseIpPacketAddress' type='checkbox' {$checked}/> <label for='gateway-nap-sip-domain-use-ip-packet-address'>{$app->translate( 'gateway-nap-sip-domain-use-ip-packet-address' )}</label><br />";
        $checked = $nap['UseCalledFromRequestURI'] ? ' checked=\'checked\'' : '';
        $buffer .= "<input id='gateway-nap-sip-use-called-from-uri' name='UseCalledFromRequestURI' type='checkbox' {$checked}/> <label for='gateway-nap-sip-use-called-from-uri'>{$app->translate( 'gateway-nap-sip-use-called-from-uri' )}</label><br />";
        $buffer .= '</fieldset>';

        $checked = $nap['Register'] ? ' checked=\'checked\'' : '';
        $buffer .= "<fieldset><legend><input id='gateway-nap-sip-register' type='checkbox' {$checked} /> <label for='gateway-nap-sip-register'>{$app->translate( 'Register' )}</label></legend>";

        $buffer .= '<table class="textAlignLeft">';
        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-username'>{$app->translate( 'Username' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-username' type='text' value='{$nap['Username']}' /></td>";
        $buffer .= '</tr>';

        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-authorization-user'>{$app->translate( 'gateway-nap-sip-authorization-user' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-authorization-user' type='text' value='{$nap['AuthorizationUser']}' /></td>";
        $buffer .= '</tr>';

        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-password'>{$app->translate( 'Password' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-password' type='password' value='{$nap['Password']}' /></td>";
        $buffer .= '</tr>';

        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-proxy'>{$app->translate( 'Proxy' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-proxy' type='text' value='{$nap['Proxy']}' /></td>";
        $buffer .= '</tr>';

        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-proxy-port'>{$app->translate( 'ProxyPort' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-proxy-port' type='text' value='{$nap['ProxyPort']}' /></td>";
        $buffer .= '</tr>';

        $buffer .= "<tr><td class='width150'><label for='gateway-nap-sip-expires'>{$app->translate( 'gateway-nap-sip-expires' )}</label>:</td>";
        $buffer .= "<td><input id='gateway-nap-sip-expires' type='text' value='{$nap['Expires']}' /></td>";
        $buffer .= '</tr></table></fieldset><br  />';

        return $buffer;
    }

    function getConfigGW( )
    {
        $kyaml = new KYaml( GatewayUtil::getGatewayConfigPath( ) );
        return $kyaml;
    }

    function getNAPTypes( )
    {
        global $sistema;

        $types = array( 'SIP' );
        //TODO: gatway support only E1 and SIP
        /*
         if( sizeof( $sistema->getSpecificDevice( "GSM" ) ) > 0 )
         $types[] = "GSM";
         if( sizeof( $sistema->getSpecificDevice( "FXO" ) ) > 0 )
         $types[] = "FXO";
         */
        if( sizeof( $sistema->getSpecificDevice( 'E1' ) ) )
        {
            $types[] = 'Trunk';
        }
        /*
         if( sizeof( $sistema->getSpecificDevice( "FXS" ) ) )
         {
         $types[] = "FXS";
         if( existsNAPFXS( ) )
         $types[] = "FXSGroup";
         }
         */

        return $types;
    }

    //TODO: port this function to KGatewayYaml class
    function searchNAPValue( $value, $yaml = null )
    {
        if( is_null( $yaml ) )
        {
            $kyaml = new KGatewayYaml( );
            $yaml = $kyaml->getYaml( );
            unset( $kyaml );
        }
        for( $i = 0; $i < sizeof( $yaml['NAPs'] ); $i++ )
        {
            if( $yaml['NAPs'][$i]['Name'] == $value )
                return $yaml['NAPs'][$i];
        }
        return null;
    }

    function existsNAPFXS( )
    {
        $kyaml = getConfigGW( );
        $yaml = $kyaml->getYaml( );

        foreach( $yaml['NAPs'] as $nap )
        {
            if( $nap['Type'] == 'FXS' )
                return true;
        }
        return false;
    }

    //TODO: port this function to KGatewayYaml class
    function _isFXSGroupChannelInUse( &$yaml, $channel )
    {
        return _isChannelInUse( $yaml, $channel, 'FXSGroup', 'Branches' );
    }

    //TODO: port this function to KGatewayYaml class
    function _isFXSChannelInUse( &$yaml, $channel )
    {
        return _isChannelInUse( $yaml, $channel, 'FXS', 'Branches' );
    }

    //TODO: port this function to KGatewayYaml class
    function _isFXOChannelInUse( &$yaml, $channel )
    {
        return _isChannelInUse( $yaml, $channel, 'FXO', 'Channels' );
    }

    //TODO: port this function to KGatewayYaml class
    function _isGSMChannelInUse( &$yaml, $channel )
    {
        return _isChannelInUse( $yaml, $channel, 'GSM', 'Channels' );
    }

    //TODO: port this function to KGatewayYaml class
    function _isTrunkChannelInUse( &$yaml, $channel )
    {
        return _isChannelInUse( $yaml, $channel, 'Trunk', 'Links' );
    }

    /**
     * Internal use only, use _is[type]ChannelInUse instead.
     *
     * TODO: port this function to KGatewayYaml class
     */
    function _isChannelInUse( &$yaml, &$channel, $type, $napkey )
    {
        foreach( $yaml['NAPs'] as $_nap )
        {
            if( $_nap['Type'] == $type && array_key_exists( $napkey, $_nap ) )
            {
                foreach( $_nap[$napkey] as $link )
                {
                    if( "{$link}" === $channel )
                    {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    //TODO: delete this function
    function verificaSeCanalJaUtilizado( $NAPType, $canal, $NAPAtual = '' )
    {
        $kyaml = getConfigGW( );
        $yaml = $kyaml->getYaml( );
        $NAPs = $yaml['NAPs'];

        foreach( $NAPs as $nap )
        {
            if( $nap['Type'] == $NAPType && $nap['Name'] != $NAPAtual )
            {
                $canais = $nap[getSectionName( $NAPType )];
                foreach( $canais as $ch )
                {
                    if( @ereg( '\[', $ch ) )
                    {
                        $tmpCh = explode( '.', $ch );
                        if( sizeof( $tmpCh ) == 2 )
                        {
                            $c = explode( '.', $canal );
                            if( $c[0] != $tmpCh[0] )
                            {
                                // return false;
                            }
                            else
                            {
                                $tmp = explode( '-', $tmpCh[1] );
                                $tmp[0] = str_replace( '[', '', $tmp[0] );
                                $tmp[1] = str_replace( ']', '', $tmp[1] );
                                if( $c[1] < $tmp[0] || $c[1] > $tmp[1] )
                                {
                                    // return false;
                                }
                                else
                                    return true;
                            }
                        }
                        else
                        {
                            $c = explode( '.', $canal );
                            $tmpCh = explode( '.', $ch );
                            if( $c[0] != $tmpCh[0] || $c[1] != $tmpCh[1] )
                            {
                                // return false;
                            }
                            else
                            {
                                $tmp = str_replace( '[', '', $ch[2] );
                                $tmp = str_replace( ']', '', $tmp );
                                $tmp = explode( '-', $tmp );
                                if( $c[2] < $tmp[0] || $c[2] > $tmp[1] )
                                {
                                    // return false;
                                }
                                else
                                    return true;
                            }
                        }
                    }
                    else
                    {
                        $tmpCH = explode( '.', $ch );
                        if( sizeof( $tmpCH ) == 2 )
                        {
                            $c = explode( '.', $canal );
                            if( $tmpCH[0] == $c[0] && $tmpCH[1] == $c[1] )
                            {
                                return true;
                            }
                        }
                        else
                        {
                            if( $canal == $ch )
                                return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    //TODO: delete this function
    function checkRealValue( $var )
    {
        if( $var == 'true' )
            return true;
        elseif( $var == 'false' )
            return false;
        else
            return $var;
    }

    //TODO: delete this function
    function getSectionName( $type )
    {
        switch ($type)
        {
            /*
             case 'GSM':
             case 'FXO':
             return 'Channels';
             */
            case 'Trunk':
                return 'Links';
            /*
             case 'FXS':
             case 'FXSGroup':
             return 'Branches';
             */
            default:
                return '';
        }
    }

    //TODO: delete this function
    function getNAPFXS( )
    {
        $kyaml = getConfigGW( );
        $yaml = $kyaml->getYaml( );

        foreach( $yaml['NAPs'] as $nap )
        {
            if( $nap['Type'] == 'FXS' )
                return $nap;
        }
        return '';
    }
