<?php
    session_name( 'elastixSession' );
    @session_start( );

    function _moduleContent( &$smarty, $module_name )
    {
        global $dicionario, $sistema, $image_dir, $invDevices, $boardNames, $module_dir;

        require_once 'modules/khomp/constants.php';
        require_once KROOT . '/classes/KSystem.php';
        $app = KSystem::getInstance( );

        require_once KROOT . '/topo.php';
        require_once KROOT . '/rodape.php';
        require_once KROOT . '/util.php';
        require_once KCONFIG . '/languages/dictionary.php';
        require_once KCONFIG . '/classes/classKSistema.php';

        $image_dir = "modules/khomp";
        $module_dir = "modules/{$module_name}";

        if( !isset( $_SESSION['sis'] ) )
        {
            $sistema = new KSistema( $app->getLanguage( ) );
        }
        else
        {
            $sistema = unserialize( $_SESSION['sis'] );
            $sistema->setLanguage( $app->getLanguage( ) );
        }
        $_SESSION['sis'] = serialize( $sistema );

        $_SESSION['loginAccess']['configuration'] = 'full';
        $_SESSION['loginAccess']['monitoring'] = 'full';
        $_SESSION['loginAccess']['diagnostic'] = 'full';
        $_SESSION['loginAccess']['administration'] = 'full';
        $_SESSION['login'] = 'elastix-user';
        $_SESSION['installDir'] = '/etc/khomp/';

        $ajaxTo = isset( $_REQUEST['ajaxTo'] ) ? $_REQUEST['ajaxTo'] : NULL;
        if( isset( $ajaxTo ) )
        {
            require_once KROOT . '/json_util.php';
            require_once KCONFIG . '/ajax/includeAjaxFiles.php';
            if( function_exists( $AjaxFunctions[$ajaxTo] ) )
            {
                return call_user_func_array( $AjaxFunctions[$ajaxTo], array( $_REQUEST ) );
            }
            else
            {
                return "Undefined function {$ajaxTo}";
            }
        }
        else
        {
            reimplementation( $smarty, $module_name );
        }

        return $smarty->fetch( "/var/www/html/modules/{$module_name}/themes/default/default.tpl" );
    }

    function reimplementation( $smarty, $module_name )
    {
        global $image_dir;
        $app = KSystem::getInstance( );

        require_once KROOT . '/json_util.php';
        require_once KCONFIG . '/ajax/includeAjaxFiles.php';

        $menu = call_user_func_array( $AjaxFunctions['showTreeMenu'], array( $_REQUEST ) );
        $smarty->assign( 'MENU', $menu );
        $smarty->assign( 'CHANGEVIEW', 'showDevices' );
        $smarty->assign( 'SECTION', 'menu-device' );
        $smarty->assign( 'FORM', showDevices( $_REQUEST ) );

        $smarty->assign( 'LEGEND', $app->translate( 'sisConfig' ) );

        $smarty->assign( 'CONFIG_SAVED', $app->translate( 'configurationSaved' ) );

        $smarty->assign( 'MODULO_PAI', 'modules/khomp' );
        $smarty->assign( 'MODULO', "modules/{$module_name}" );
        $topo = Topo::printTopo( '', '', 'none', '', '', 'modules/khomp' );
        $smarty->assign( 'TOP', $topo );
        $rodape = Rodape::printRodape( );
        $smarty->assign( 'FOOTER', $rodape );

        //ataching timestamp to prevent cache
        $smarty->assign( 'PRINCIPAL_CSS_TS', filemtime( "/var/www/html/modules/{$module_name}/css/principal.css" ) );
        $smarty->assign( 'KWEBCONFIG_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/js/kwebconfig.js" ) );
        $smarty->assign( 'GERAL_JS_TS', filemtime( '/var/www/html/modules/khomp/js/geral.js' ) );
        $smarty->assign( 'GERAL_CSS_TS', filemtime( '/var/www/html/modules/khomp/js/geral.css' ) );
        $smarty->assign( 'JQUERY_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.min.js' ) );

        $smarty->assign( 'UI_CSS_TS', filemtime( "/var/www/html/modules/{$module_name}/css/jquery.ui.all.css" ) );
        $smarty->assign( 'TREEVIEW_CSS_TS', filemtime( "/var/www/html/modules/{$module_name}/css/treeMenu/jquery.treeview.css" ) );
        $smarty->assign( 'TREE_JS_TS', filemtime( "/var/www/html/modules/{$module_name}/css/treeMenu/tree.js" ) );

        $smarty->assign( 'TREEVIEW_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.treeview.js' ) );
        $smarty->assign( 'VALIDATE_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery-1.6.validate.js' ) );
        $smarty->assign( 'DRAGGABLE_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.ui.draggable.js' ) );
        $smarty->assign( 'SORTABLE_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.ui.sortable.js' ) );
        $smarty->assign( 'WIDGET_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.ui.widget.js' ) );
        $smarty->assign( 'COLLAPSER_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.collapser.min.js' ) );
        $smarty->assign( 'TINPUTS_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.textinputs.js' ) );
        $smarty->assign( 'TABLESORT_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.tablesorter.min.js' ) );
        $smarty->assign( 'MASKINPUT_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.maskedinput-1.3.min.js' ) );
        $smarty->assign( 'IP_ADDR_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.input-ip-address-control-1.0.min.js' ) );
        $smarty->assign( 'JFORM_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/jquery.form.js' ) );
        $smarty->assign( 'DROPDOWN_JS_TS', filemtime( '/var/www/html/modules/khomp/js/jquery/ui.dropdownchecklist-1.4-min.js' ) );

    }
