var GLOBALAjaxURL = "index.php?rawmode=yes&menu=kdiagnostic";

function filter( )
{
    var file = $( '#file' ).val( );
    var begin = $( '#begin' ).val( );
    var end = $( '#end' ).val( );

    $( '#refreshing' ).show( );
    jQuery.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=logAnaliser&file=" + btoa(file) + '&begin=' + begin + '&end=' + end,
        dataType : "json",
        success : function( ret )
        {
            $( '#divLogAnalyser' ).html( ret['content'] );

            $( ".ui-widget-overlay" ).click( function( )
            {
                jQuery( '#divLogAnalyser' ).dialog( 'close' );
            } );

            $( "#browser-log" ).treeview( );
            $( '#refreshing' ).hide( );
            $( '#loading' ).hide( );
        }
    } );
}

function analyseDownloadSize( type )
{
    $( '#refreshing' ).show( );
    jQuery.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=analyseLogDownload&type=" + type,
        dataType : "text",
        success : function( size )
        {
            size = size.replace( /(\r\n|\n|\r)/gm, "" );

            $( '#refreshing' ).hide( );
            var msg = ajaxI18N( 'sizeOfLogGroup' );
            msg = msg.replace( '@@@', size );
            if( confirm( msg ) )
                zipLastLogs( type );
        }
    } );
}

function zipLastLogs( type )
{
    $( '#refreshing' ).show( );
    $( '#block' ).show( );

    jQuery.kajax(
    {
        type : "POST",
        data : "type=" + type,
        url : modulo_dir + "/lastLogs.php",
        dataType : "text",
        success : function( ret )
        {
            document.getElementById( 'lastLogZip' ).setAttribute( 'href', modulo_dir + '/downloadZip.php?file=' + ret );
            document.getElementById( 'downloadZipButton' ).click( );
            $( '#block' ).hide( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function diagnosticMode( action )
{
    if( action == 'active' )
        msg = 'diagnosticModeOn';
    else
        msg = 'diagnosticModeOff';

    if( ajaxConfirm( msg ) )
    {
        $('#refreshing').show();
        reload( 'no' );
        jQuery.kajax(
        {
            data : "ajaxTo=diagnosticMode&action=" + action,
            url : GLOBALAjaxURL,
            dataType : "text",
            success : function( ret )
            {
                ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                resp = ret.split( '|' );

                if( resp[0] == 'ok' )
                    ShowNotice( resp[1], true );
                else
                    ShowNotice( resp[1], false );

                $('#refreshing').hide();
                showSettings( 'settingsMenu' );
            }
        } );
    }
}

function showSettings( nameToBold )
{
    uberUnbolder( );
    boldMe( nameToBold );
    $( '#refreshing' ).show( );
    jQuery.kajax(
    {
        type : "POST",
        data : "ajaxTo=showSettingLogs",
        url : GLOBALAjaxURL,
        dataType : "text",
        success : function( ret )
        {
            $( '#right' ).html( ret );
            $( ".collapsePara", parent.document ).each( function( i, item )
            {
                $( item ).click( function( )
                {
                    $this = $( this );
                    if( $this.next( ).is( ":visible" ) )
                        $this.next( ).slideUp( );
                    else
                        $this.next( ).slideDown( );
                } );
            } );
            $( '#refreshing' ).hide( );
        }
    } );
}

function boldMe( nameToBold )
{
    $( '#' + nameToBold ).removeClass().addClass( 'fontWeightBold');
}

function uberUnbolder( )
{
    $( '#browser li span' ).each( function( i, val )
    {
        $(val).removeClass().removeClass('fontWeightBold').addClass('fontWeightNormal');
    } );
}

function reload( apply )
{
    if(apply == 'yes')
        $( '#refreshing' ).show( );

    jQuery.kajax(
    {
        type : "POST",
        url : GLOBALAjaxURL,
        data : "ajaxTo=saveSettingLogs&apply=" + apply + "&data=" + JSON.stringify( getquerystring( ) ),
        dataType : "text",
        success : function( ret )
        {
            if( ret.length > 0 )
            {
                ret = ret.replace( /(\r\n|\n|\r)/gm, "" );
                resp = ret.split( '|' );
                $( '#refreshing' ).hide( );

                if( resp[0] == 'ok' )
                    ShowNotice( resp[1], true );
                else
                    ShowNotice( resp[1], false );

                showSettings( 'settingsMenu' );
            }
            if(apply == 'yes')
                $( '#refreshing' ).hide( );
        }
    } );
}

function getquerystring( )
{
    var objQueryString = { };
    $( ':radio:checked' ).each( function( i, e )
    {
        objQueryString[$( e ).attr( 'name' )] = $( e ).val( );
    } );
    return objQueryString;
}

function showDir( dir, CompToBold )
{
    $( '#refreshing' ).show( );
    jQuery.kajax(
    {
        type : "POST",
        data : "ajaxTo=showFileDir&dir=" + dir,
        url : GLOBALAjaxURL,
        dataType : "text",
        success : function( ret )
        {
            $( '#right' ).html( ret );
            $( '#refreshing' ).hide( );
        }
    } );
    uberUnbolder( );
    $(CompToBold).removeClass().addClass('fontWeightBold');
}

$( document ).ready( function( )
{
    var buttons = $( "#yesno button" ).click( function( e )
    {
        var yes = buttons.index( this ) === 0;
    } );

    $( "#prompt form" ).submit( function( e )
    {
        triggers.eq( 1 ).overlay( ).close( );
        var input = $( "input", this ).val( );
        triggers.eq( 1 ).html( input );
        return e.preventDefault( );
    } );

} );

$( function( )
{
    $( "ul.tabs" ).tabs( "div.panes > div" );
} );

function parseLog( content )
{
    if( typeof( content ) == "string" )
        var contentArray = content.split( "\n" );
    else
        var contentArray = content;

    var usecolors = $( '#log-viewer-use-colors' ).is( ':checked' );
    var arraylength = contentArray.length;

    for( var line = 0; line < arraylength; line++ )
    {
        var cls = "";
        if( $.trim( contentArray[line] ).length == 0 )
        {
            contentArray[line] = " ";
        }
        else
        {
            switch( contentArray[line].substr( 0, 2 ) )
            {
                case "W|":
                    cls = "warning";
                    break;
                case "E|":
                    cls = "error";
                    break;
                case "I|":
                    cls = "info";
                    break;
                case "T|":
                    cls = "trace";
                    break;
                case "N|":
                    cls = "notice";
                    break;
            }
            if( !usecolors )
            {
                cls += " nocolors";
            }
        }
        contentArray[line] = "<p class='" + cls + "'>" + $( "<span />" ).text( contentArray[line] ).html() + "</p>";
    }
    return contentArray.join( "" );
}

function openLog( file )
{
    $( '#refreshing' ).show( );
    $( '#divLogView .loading' ).show( );
    $.kajax(
    {
        type : "POST",
        data : "ajaxTo=printLog&file=" + file,
        url : GLOBALAjaxURL,
        dataType : "json",
        success : function( ret )
        {
            var canvas = $( '#divLogView' );
            var top = $( '#divLogViewTopo' );
            var content = $( '#divLogViewConteudo' );

            canvas.dialog( "destroy" );
            top.html( ret['topo'] );
            content.html( parseLog( ret['content'] ) );

            $( '#log-viewer-use-colors' ).click( function(){
                if( $(this).is(":checked"))
                    $('#divLogViewConteudo p').removeClass( 'nocolors');
                else
                    $('#divLogViewConteudo p').addClass( 'nocolors');
            } );

            $( '#divLogView' ).dialog(
            {
                title : ret['title'],
                modal : true,
                width : $(window).width() - 60,
                height : $(window).height() - 40
            } );
            content.height( canvas.height() - top.height() - 20 );

            $( ".ui-widget-overlay" ).click( function( )
            {
                $( '#divLogView' ).dialog( 'destroy' );
            } );

            setScrollAtBottom( '#divLogViewConteudo' );
            $( '#refreshing' ).hide( );
            $( '#divLogView .loading' ).hide( );
        }
    } );
}

function openOverlay( file )
{
    $( '#refreshing' ).show( );
    jQuery.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=logAnaliser&file=" + file,
        dataType : "json",
        success : function( ret )
        {
            $( '#divLogAnalyser' ).html( ret['content'] );
            $( '#divLogAnalyser' ).dialog(
            {
                title : ret['title'],
                modal : true,
                draggable : true,
                hide : "slow",
                show : "slow",
                height : 850,
                minHeight : 700,
                minWidth : 700
            } );

            $( ".ui-widget-overlay" ).click( function( )
            {
                jQuery( '#divLogAnalyser' ).dialog( 'close' );
            } );

            $( '#refreshing' ).hide( );
            $( '#loading' ).hide( );
        }
    } );
}

function showMoreLogs( file, oper )
{
    $( '#divLogView .loading' ).show( );
    var paginator = $( '#paginator' ).val( );

    $.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showMoreLogs&file=" + file + "&oper=" + oper + "&paginator=" + paginator,
        dataType : "json",
        success : function( json )
        {
            if( countElements( json['lines'] ) > 0 )
            {
                $( '#divLogViewConteudo' ).html( parseLog( json['lines'] ) );

                // top of the file
                if( json['first'] <= 0 )
                {
                    $( '#forward' ).removeClass().addClass('green-light');
                    $( '#last' ).removeClass().addClass('green-light');
                    $( '#back' ).removeClass().addClass('backgroundGray');
                    $( '#first' ).removeClass().addClass('backgroundGray');
                    $( '#first' ).attr( 'disabled', 'true' );
                    $( '#back' ).attr( 'disabled', 'true' );
                    $( '#last' ).removeAttr( 'disabled' );
                    $( '#forward' ).removeAttr( 'disabled' );
                }
                else
                {
                    //middle of file
                    if( json['last'] < json['fileSize'] && json['first'] > 0 )
                    {
                        $( '#back' ).removeClass().addClass('green-light');
                        $( '#forward' ).removeClass().addClass('green-light');
                        $( '#first' ).removeClass().addClass('green-light');
                        $( '#last' ).removeClass().addClass('green-light');
                        $( '#back' ).removeAttr( 'disabled' );
                        $( '#forward' ).removeAttr( 'disabled' );
                        $( '#first' ).removeAttr( 'disabled' );
                        $( '#last' ).removeAttr( 'disabled' );
                    }
                    //end of file
                    else
                    {
                        $( '#back' ).removeClass().addClass('green-light');
                        $( '#first' ).removeClass().addClass('green-light');
                        $( '#forward' ).removeClass().addClass('backgroundGray');
                        $( '#last' ).removeClass().addClass('backgroundGray');
                        $( '#forward' ).attr( 'disabled', 'true' );
                        $( '#last' ).attr( 'disabled', 'true' );
                        $( '#back' ).removeAttr( 'disabled' );
                        $( '#first' ).removeAttr( 'disabled' );
                    }
                }
            }
            setScrollAtBottom( '#divLogViewConteudo' );
            $( '#divLogView .loading' ).hide( );
        }
    } );
}


function goToEnd( )
{
    var bott = document.getElementById( 'goBottom' );
    if( bott != null && bott != 'undefined' )
        bott.click( );
}

function botaefeito( comp )
{
    $( comp ).addClass( 'box-shadow' );
}

function tiraefeito( comp )
{
    $( comp ).removeClass( 'box-shadow' );
}

function showSettingsLogsAdvanced( )
{
    $( '#logSettingAdvanced' ).show( );
    $( '#showSettingsLogs' ).hide( );
    $( '#hideSettingsLogs' ).show( );
}

function hideSettingsLogsAdvanced( )
{
    $( '#logSettingAdvanced' ).hide( );
    $( '#showSettingsLogs' ).show( );
    $( '#hideSettingsLogs' ).hide( );
}

function browserTest( )
{
    var userAgent = navigator.userAgent.toLowerCase( );
    if( navigator.userAgent.toLowerCase( ).indexOf( 'chrome' ) > -1 )
        return ajaxConfirm( 'downloadFile' );
    else
        return true;
}

function zipBigFile( file )
{
    if( ajaxConfirm( 'zipAndDownloadFile' ) )
    {
        $( '#block' ).show( );
        jQuery.kajax(
        {
            type : "POST",
            data : "file=" + file + "&type=file",
            url : "zip.php",
            dataType : "text",
            success : function( ret )
            {
                if( ret != '' )
                {
                    document.getElementById( 'zipFileLink' ).setAttribute( 'href', modulo_dir + '/downloadZip.php?file=' + ret );
                    document.getElementById( 'zipFileLink' ).click( );
                    document.getElementById( 'zipFileButton' ).click( );
                    $( '#block' ).hide();
                }
                else
                    ajaxAlert( 'errorToZipFile' );

                $( '#block' ).hide( );
            }
        } );
    }
}

function unblock( )
{
    $( 'loading' ).hide( );
}

function unBold( alvo )
{
    var filho = alvo.firstElementChild;
    while( filho != null )
    {
        if( filho.firstElementChild != null )
            unBold( filho.firstElementChild );
        filho = filho.nextElementSibling;
    }
}

function showMessages( nameToBold )
{
    $( '#refreshing' ).show( );
    jQuery.kajax(
    {
        type : "POST",
        url : GLOBALAjaxURL,
        data : "ajaxTo=showMessage",
        dataType : "text",
        success : function( ret )
        {
            $( '#right' ).html( ret );
            $( '#refreshing' ).hide( );
            setScrollAtBottom( '#showMessages' );
        }
    } );

    if( $( '#' + nameToBold ).lenght > 0 )
        $( '#' + nameToBold ).removeClass('fontWeightBold').addClass( 'fontWeightNormal');

    uberUnbolder( );

    if( nameToBold != undefined )
        boldMe( nameToBold );
}

function setScrollAtBottom( selector )
{
    var _div = $( selector );
    if( _div )
    {
        _div.prop(
        {
            scrollTop : _div.prop( 'scrollHeight' )
        } );
    }
}

function setScrollAtTop( selector )
{
    var _div = $( selector );
    if( _div )
    {
        _div.prop(
        {
            scrollTop : 0
        } );
    }
}

function changeArrow( place )
{
    innerString = place.innerHTML;
    if( innerString[1] == "-" )
        place.innerHTML = innerString.replace( "-", "+" );
    else
        place.innerHTML = innerString.replace( "+", "-" );
}